
      '=================================================================================================|
      'QPrn was made as a replacement for QPrinter with the ability of showing PageSetup and Printdialog
      'I took QPageSetup version 1.3 to begin (original code D. Glodt, modified by John Kelly 8/2005)
      'added big parts from QPrint.inc (David Burkley, Oct. 24th, 2010, Email: burkleyd@yahoo.com),
      'from Printer.bas (programmed by John White (danilo_yoingco@yahoo.co.uk)) and from
      'PrinterDialog.inc (don't know who made this) and played a lot with all that to find a working
      'balance. Thank you for all your work, making this possible !
      '
      'QPrn.inc Version 1.0 , Nov. 01, 2010, V. Dobiasch (vdobiasch@2ya.de), donated to Public Domain
      'Version 1.1 , Nov. 04, 2010, BkMode added for transparent background at TEXTOUT and TEXTRECT
      '                             RicheditOut Header and Footer added
      'Version 1.2 , Mar. 19, 2011, Bugfixes, PrintPreview added , inspired by David Burkley
      '                             HeaderMiddle, HeaderRight, FooterMiddle, FooterRight added.
      '=================================================================================================|


TYPE DEVMOD
    dmDeviceName AS STRING * 32        '64
    dmSpecVersion AS SHORT
    dmDriverVersion AS SHORT
    dmSize AS SHORT
    dmDriverExtra AS SHORT
    dmFields AS DWORD
    dmOrientation AS SHORT
    dmPaperSize AS SHORT
    dmPaperLength AS SHORT
    dmPaperWidth AS SHORT
    dmScale AS SHORT
    dmCopies AS SHORT
    dmDefaultSource AS SHORT
    dmPrintQuality AS SHORT
    dmColor AS SHORT
    dmDuplex AS SHORT
    dmYResolution AS SHORT
    dmTTOption AS SHORT
    dmCollate AS SHORT
    dmFormName AS STRING * 32        '64
    dmLogPixels AS WORD
    dmBitsPerPel AS DWORD
    dmPelsWidth AS DWORD
    dmPelsHeight AS DWORD
    dmDisplayFlags AS DWORD
    dmNup AS DWORD
    dmICMMethod AS DWORD
    dmICMIntent AS DWORD
    dmMediaType AS DWORD
    dmDitherType AS DWORD
    dmReserved1 AS DWORD
    dmReserved2 AS DWORD
    dmPanningWidth AS DWORD
    dmPanningHeight AS DWORD
END TYPE

TYPE FORMATRANGE
    hdc AS LONG
    hdcTarget AS LONG
    rc_Left AS LONG
    rc_Top AS LONG
    rc_Right AS LONG
    rc_Bottom AS LONG
    rcPage_Left AS LONG
    rcPage_Top AS LONG
    rcPage_Right AS LONG
    rcPage_Bottom AS LONG
    chrg_cpMin AS LONG
    chrg_cpMax AS LONG
END TYPE

$IFNDEF __RQINC2
    $IFNDEF __RQINC
        CONST False = 0
        CONST True = 1

        CONST clBlack = 0
        CONST clWhite = &HFFFFFF
        CONST clBlue = &HFF0000
        CONST clGreen = &H00FF00
        CONST clRed = &H0000FF
        CONST clPurple = &HFF00FF
        CONST clYellow = &H00FFFF

        CONST fsBold = 0
        CONST fsItalic = 1
        CONST fsUnderline = 2
        CONST fsStrikeOut = 3
    $ENDIF
    $DEFINE UDTPTR ABS

          'Constants for dmPaperSize
    $DEFINE DMPAPER_LETTER = 1
    $DEFINE DMPAPER_FIRST = DMPAPER_LETTER        'Letter 8 1/2 x 11 in
    $DEFINE DMPAPER_LETTERSMALL = 2        'Letter Small 8 1/2 x 11 in
    $DEFINE DMPAPER_TABLOID = 3        'Tabloid 11 x 17 in
    $DEFINE DMPAPER_LEDGER = 4        'Ledger 17 x 11 in
    $DEFINE DMPAPER_LEGAL = 5        'Legal 8 1/2 x 14 in
    $DEFINE DMPAPER_STATEMENT = 6        'Statement 5 1/2 x 8 1/2in
    $DEFINE DMPAPER_EXECUTIVE = 7        'Executive 7 1/4 x 10 1/2in
    $DEFINE DMPAPER_A3 = 8        'A3 297 x 420 mm
    $DEFINE DMPAPER_A4 = 9        'A4 210 x 297 mm
    $DEFINE DMPAPER_A4SMALL = 10        'A4 Small 210 x 297 mm
    $DEFINE DMPAPER_A5 = 11        'A5 148 x 210 mm
    $DEFINE DMPAPER_B4 = 12        'B4 250 x 354
    $DEFINE DMPAPER_B5 = 13        'B5 182 x 257 mm
    $DEFINE DMPAPER_FOLIO = 14        'Folio 8 1/2 x 13 in
    $DEFINE DMPAPER_QUARTO = 15        'Quarto 215 x 275 mm
    $DEFINE DMPAPER_10X14 = 16        '10x14 in
    $DEFINE DMPAPER_11X17 = 17        '11x17 in
    $DEFINE DMPAPER_NOTE = 18        'Note 8 1/2 x 11 in
    $DEFINE DMPAPER_ENV_9 = 19        'Envelope #9 3 7/8 x 8 7/8
    $DEFINE DMPAPER_ENV_10 = 20        'Envelope #10 4 1/8 x 9 1/2
    $DEFINE DMPAPER_ENV_11 = 21        'Envelope #11 4 1/2 x 10 3/8
    $DEFINE DMPAPER_ENV_12 = 22        'Envelope #12 4 \276 x 11
    $DEFINE DMPAPER_ENV_14 = 23        'Envelope #14 5 x 11 1/2
    $DEFINE DMPAPER_CSHEET = 24        'C size sheet
    $DEFINE DMPAPER_DSHEET = 25        'D size sheet
    $DEFINE DMPAPER_ESHEET = 26        'E size sheet
    $DEFINE DMPAPER_ENV_DL = 27        'Envelope DL 110 x 220mm
    $DEFINE DMPAPER_ENV_C5 = 28        'Envelope C5 162 x 229 mm
    $DEFINE DMPAPER_ENV_C3 = 29        'Envelope C3 324 x 458 mm
    $DEFINE DMPAPER_ENV_C4 = 30        'Envelope C4 229 x 324 mm
    $DEFINE DMPAPER_ENV_C6 = 31        'Envelope C6 114 x 162 mm
    $DEFINE DMPAPER_ENV_C65 = 32        'Envelope C65 114 x 229 mm
    $DEFINE DMPAPER_ENV_B4 = 33        'Envelope B4 250 x 353 mm
    $DEFINE DMPAPER_ENV_B5 = 34        'Envelope B5 176 x 250 mm
    $DEFINE DMPAPER_ENV_B6 = 35        'Envelope B6 176 x 125 mm
    $DEFINE DMPAPER_ENV_ITALY = 36        'Envelope 110 x 230 mm
    $DEFINE DMPAPER_ENV_MONARCH = 37        'Envelope Monarch 3.875 x7.5 in
    $DEFINE DMPAPER_ENV_PERSONAL = 38        '6 3/4 Envelope 3 5/8 x 6 1/2 in
    $DEFINE DMPAPER_FANFOLD_US = 39        'US Std Fanfold 14 7/8 x 11 in
    $DEFINE DMPAPER_FANFOLD_STD_GERMAN = 40        'German Std Fanfold 8 1/2 x 12 in
    $DEFINE DMPAPER_FANFOLD_LGL_GERMAN = 41        'German Legal Fanfold 8 1/2 x 13 in

          'Constants for dmPrintQuality
    $DEFINE DMRES_DRAFT = (- 1)
    $DEFINE DMRES_HIGH = (- 4)
    $DEFINE DMRES_LOW = (- 2)
    $DEFINE DMRES_MEDIUM = (- 3)
          'Constants for dmTTOption
    $DEFINE DMTT_BITMAP = 1
    $DEFINE DMTT_DOWNLOAD = 2
    $DEFINE DMTT_DOWNLOAD_OUTLINE = 4
    $DEFINE DMTT_SUBDEV = 3
          'Constants for dmColor
    $DEFINE DMCOLOR_COLOR = 2
    $DEFINE DMCOLOR_MONOCHROME = 1
          'Constants for dmDuplex
    $DEFINE DMDUP_HORIZONTAL = 3
    $DEFINE DMDUP_SIMPLEX = 1
    $DEFINE DMDUP_VERTICAL = 2
          'Constants for dmOrient
    $DEFINE DMORIENT_PORTRAIT = 1
    $DEFINE DMORIENT_LANDSCAPE = 2
          'Constants for dmFileds
    $DEFINE DM_ORIENTATION &H00000001
    $DEFINE DM_PAPERSIZE &H00000002
    $DEFINE DM_PAPERLENGTH &H00000004
    $DEFINE DM_PAPERWIDTH &H00000008
    $DEFINE DM_SCALE &H00000010
    $DEFINE DM_POSITION &H00000020
    $DEFINE DM_NUP &H00000040
    $DEFINE DM_DISPLAYORIENTATION &H00000080
    $DEFINE DM_COPIES &H00000100
    $DEFINE DM_DEFAULTSOURCE &H00000200
    $DEFINE DM_PRINTQUALITY &H00000400
    $DEFINE DM_COLOR &H00000800
    $DEFINE DM_DUPLEX &H00001000
    $DEFINE DM_YRESOLUTION &H00002000
    $DEFINE DM_TTOPTION &H00004000
    $DEFINE DM_COLLATE &H00008000
    $DEFINE DM_FORMNAME &H00010000
    $DEFINE DM_LOGPIXELS &H00020000
    $DEFINE DM_BITSPERPEL &H00040000
    $DEFINE DM_PELSWIDTH &H00080000
    $DEFINE DM_PELSHEIGHT &H00100000
    $DEFINE DM_DISPLAYFLAGS &H00200000
    $DEFINE DM_DISPLAYFREQUENCY &H00400000

          'these are renamed windows constants, to prevent conflicts
    $DEFINE PSD_DEFAULTMINMARGINS 0
    $DEFINE PSD_MINMARGINS &H1
    $DEFINE PSD_MARGINS &H2
    $DEFINE PSD_INTHOUSANDTHSOFINCHES &H4
    $DEFINE PSD_INHUNDREDTHSOFMILLIMETERS &H8
    $DEFINE PSD_DISABLEMARGINS &H10
    $DEFINE PSD_DISABLEPRINTER &H20
    $DEFINE PSD_NOWARNING &H80
    $DEFINE PSD_DISABLEORIENTATION &H100
    $DEFINE PSD_DISABLEPAPER &H200
    $DEFINE PSD_RETURNDEFAULT &H400
    $DEFINE PSD_SHOWHELP &H800
    $DEFINE PSD_ENABLEPAGESETUPHOOK &H2000
    $DEFINE PSD_ENABLEPAGESETUPTEMPLATE &H8000
    $DEFINE PSD_ENABLEPAGESETUPTEMPLATEHANDLE &H20000
    $DEFINE PSD_ENABLEPAGEPAINTHOOK &H40000
    $DEFINE PSD_DISABLEPAGEPAINTING &H80000
    $DEFINE PSD_NONETWORKBUTTON &H200000
    $DEFINE WM_INITDIALOG_PSD &H110

    TYPE TPSD
        lStructSize AS LONG
        hWndOwner AS LONG
        hDevMode AS LONG
        hDevNames AS LONG
        Flags AS LONG
        ptPaperSizeX AS LONG
        ptPaperSizeY AS LONG
        rtMinMarginLeft AS LONG
        rtMinMarginTop AS LONG
        rtMinMarginRight AS LONG
        rtMinMarginBottom AS LONG
        rtMarginLeft AS LONG
        rtMarginTop AS LONG
        rtMarginRight AS LONG
        rtMarginBottom AS LONG
        hInstance AS LONG
        lParam AS LONG
        lpfnPageSetupHook AS LONG
        lpfnPagePaintHook AS LONG
        lpPageSetupTemplate AS LONG
        hPageSetupTemplate AS LONG
    END TYPE

    $DEFINE BOOLEAN LONG        'need this line for extended types

    $IFNDEF __WIN32API        'windows 32 definitions
        DECLARE FUNCTION CallWindowProc LIB "user32.dll" ALIAS "CallWindowProcA"(lpPrevWndFunc AS LONG , hwnd AS LONG , Msg AS LONG , wParam AS LONG , lParam AS LONG) AS LONG
        DECLARE FUNCTION GetSystemMetrics LIB "user32" ALIAS "GetSystemMetrics"(nIndex AS LONG) AS LONG
        DECLARE FUNCTION GetDC LIB "user32" ALIAS "GetDC"(hWnd AS LONG) AS LONG
        DECLARE FUNCTION ShowWindow LIB "user32" ALIAS "ShowWindow"(hWnd AS LONG , nCmdShow AS LONG) AS LONG
        DECLARE FUNCTION SetForegroundWindow LIB "user32" ALIAS "SetForegroundWindow"(hWnd AS LONG) AS LONG
        DECLARE FUNCTION SendMessageAPI LIB "user32" ALIAS "SendMessageA"(hwnd AS LONG , wMsg AS LONG , wParam AS LONG , lParam AS LONG) AS LONG
        DECLARE FUNCTION GetDeviceCaps LIB "gdi32.dll" ALIAS "GetDeviceCaps"(hdc AS LONG , nIndex AS LONG) AS LONG
        DECLARE FUNCTION SelectObject LIB "gdi32" ALIAS "SelectObject"(hdc AS LONG , hObject AS LONG) AS LONG
        DECLARE FUNCTION DeleteObject LIB "gdi32" ALIAS "DeleteObject"(hObject AS LONG) AS LONG
        DECLARE FUNCTION DeleteDC LIB "gdi32" ALIAS "DeleteDC"(hdc AS LONG) AS LONG
        DECLARE FUNCTION MoveToEx LIB "gdi32.dll" ALIAS "MoveToEx"(hdc AS LONG , x AS LONG , y AS LONG , curPos AS LONG) AS LONG
        DECLARE FUNCTION CreatePen LIB "gdi32" ALIAS "CreatePen"(nPenStyle AS LONG , nWidth AS LONG , crColor AS LONG) AS LONG
        DECLARE FUNCTION LineTo LIB "gdi32.dll" ALIAS "LineTo"(hdc AS LONG , x AS LONG , y AS LONG) AS LONG
        DECLARE FUNCTION RoundRect LIB "gdi32" ALIAS "RoundRect"(hdc AS LONG , X1 AS LONG , Y1 AS LONG , X2 AS LONG , Y2 AS LONG , X3 AS LONG , Y3 AS LONG) AS LONG
        DECLARE FUNCTION StretchBlt LIB "gdi32" ALIAS "StretchBlt"(hdc AS LONG , x AS LONG , y AS LONG , nWidth AS LONG , nHeight AS LONG , hSrcDC AS LONG , xSrc AS LONG , ySrc AS LONG , nSrcWidth AS LONG , nSrcHeight AS LONG , dwRop AS LONG) AS LONG
        DECLARE FUNCTION SetBkMode LIB "gdi32.dll" ALIAS "SetBkMode"(hdc AS LONG , mode AS LONG) AS LONG
        DECLARE FUNCTION GetDesktopWindow LIB "user32" ALIAS "GetDesktopWindow"() AS LONG
        DECLARE FUNCTION ReleaseDC LIB "user32" ALIAS "ReleaseDC"(hWnd AS LONG , hdc AS LONG) AS LONG
        DECLARE FUNCTION GetFocus LIB "user32" ALIAS "GetFocus"() AS LONG
        DECLARE FUNCTION SetFocus LIB "User32" ALIAS "SetFocus"(hwnd AS LONG) AS LONG
        TYPE RECT
            Left AS LONG
            Top AS LONG
            Right AS LONG
            Bottom AS LONG
        END TYPE
        CONST SRCCOPY = &HCC0020        '(DWORD) dest = source
        CONST SRCPAINT = &HEE0086        '(DWORD) dest = source OR dest
        CONST SRCAND = &H8800C6        '(DWORD) dest = source AND dest
        CONST SRCINVERT = &H660046        '(DWORD) dest = source XOR dest
        CONST SRCERASE = &H440328        '(DWORD) dest = source AND (NOT dest )
        CONST NOTSRCCOPY = &H330008        '(DWORD) dest = (NOT source)
        CONST NOTSRCERASE = &H1100A6        '(DWORD) dest = (NOT src) AND (NOT dest)
        CONST MERGECOPY = &HC000CA        '(DWORD) dest = (source AND pattern)
        CONST MERGEPAINT = &HBB0226        '(DWORD) dest = (NOT source) OR dest
        CONST PATCOPY = &HF00021        '(DWORD) dest = pattern
        CONST PATPAINT = &HFB0A09        '(DWORD) dest = DPSnoo
        CONST PATINVERT = &H5A0049        '(DWORD) dest = pattern XOR dest
        CONST DSTINVERT = &H550009        '(DWORD) dest = (NOT dest)
        CONST BLACKNESS = &H42        '(DWORD) dest = BLACK
        CONST WHITENESS = &HFF0062        '(DWORD) dest = WHITE
        CONST TRANSPARENT = 1
        CONST OPAQUE = 2
        CONST HORZRES = &H8
        CONST VERTRES = &HA
    $ENDIF
$ENDIF
DECLARE FUNCTION GetWindowRectangle LIB "user32" ALIAS "GetWindowRect"(hWnd AS LONG , ByRef lpRect AS RECT) AS LONG

TYPE PRNTDLG
    lStructSize AS LONG
    hwndOwner AS LONG
    hDevMode AS LONG
    hDevNames AS LONG
    hdc AS LONG
    flags AS LONG
    nFromPage AS WORD
    nToPage AS WORD
    nMinPage AS WORD
    nMaxPage AS WORD
    nCopies AS WORD
    hInstance AS LONG
    lCustData AS LONG
    lpfnPrintHook AS LONG
    lpfnSetupHook AS LONG
    lpPrintTemplateName AS LONG
    lpSetupTemplateName AS LONG
    hPrintTemplate AS LONG
    hSetupTemplate AS LONG
END TYPE

TYPE PRNDefaults
    pDatatype AS LONG
    pDevMode AS LONG
    DesiredAccess AS LONG
END TYPE

TYPE tagSIZE
    cx AS LONG
    cy AS LONG
END TYPE

TYPE DocInf
    cbSize AS INTEGER
    lpszDocName AS LONG
    lpszOutput AS LONG
    lpszDatatype AS LONG /  / Windows 95 only; ignored on Windows NT
    fwType AS DWORD /  / Windows 95 only; ignored on Windows NT
END TYPE

DECLARE SUB CopyMemory LIB "kernel32.dll" ALIAS "RtlMoveMemory"(ByVal dest AS LONG , ByVal source AS LONG , ByVal numBytes AS LONG)
DECLARE FUNCTION TextOutA LIB "gdi32.dll" ALIAS "TextOutA"(hdc AS LONG , x AS LONG , y AS LONG , buffer AS LONG , bufsize AS LONG) AS LONG
DECLARE FUNCTION PageSetupDlgA LIB "COMDLG32" ALIAS "PageSetupDlgA"(Ptr AS TPSD) AS LONG
DECLARE FUNCTION CreateDCA LIB "gdi32" ALIAS "CreateDCA"(lpDriverName AS STRING , lpDeviceName AS STRING , lpOutput AS STRING , lpInitData AS DEVMOD) AS LONG
DECLARE FUNCTION PrintDlgA LIB "comdlg32.dll" ALIAS "PrintDlgA"(pPrintdlg AS PRNTDLG) AS LONG

$IFNDEF __WIN32API        'windows 32 definitions
    $DEFINE PRINTER_ACCESS_ADMINISTER &H4
    $DEFINE PRINTER_ACCESS_USE &H8
    $DEFINE STANDARD_RIGHTS_REQUIRED &HF0000
    $DEFINE PRINTER_ALL_ACCESS &HF000C
    $DEFINE EM_FORMATRANGE &H439
          'Constants for dmDefaultSource
    $DEFINE DMBIN_UPPER 1
    $DEFINE DMBIN_FIRST 1
    $DEFINE DMBIN_ONLYONE 1
    $DEFINE DMBIN_LOWER 2
    $DEFINE DMBIN_MIDDLE 3
    $DEFINE DMBIN_MANUAL 4
    $DEFINE DMBIN_ENVELOPE 5
    $DEFINE DMBIN_ENVMANUAL 6
    $DEFINE DMBIN_AUTO 7
    $DEFINE DMBIN_TRACTOR 8
    $DEFINE DMBIN_SMALLFMT 9
    $DEFINE DMBIN_LARGEFMT 10
    $DEFINE DMBIN_LARGECAPACITY 11
    $DEFINE DMBIN_CASSETTE 14
    $DEFINE DMBIN_FORMSOURCE 15
    $DEFINE DMBIN_LAST 14

    CONST PHYSICALWIDTH = &H6E
    CONST PHYSICALHEIGHT = &H6F
    CONST PHYSICALOFFSETX = &H70
    CONST PHYSICALOFFSETY = &H71

    TYPE LOGBRUSH
        lbStyle AS LONG
        lbColor AS LONG
        lbHatch AS LONG
    END TYPE

    DECLARE FUNCTION CreateEnhMetaFile LIB "gdi32" ALIAS "CreateEnhMetaFileA"(hdcRef AS LONG , lpFilename AS LONG , ByRef lpRect AS RECT , lpDescription AS LONG) AS LONG
    DECLARE FUNCTION PlayEnhMetaFile LIB "gdi32" ALIAS "PlayEnhMetaFile"(hDC AS LONG , hEMF AS LONG , ByRef lpRect AS RECT) AS LONG
    DECLARE FUNCTION DeleteEnhMetaFile LIB "gdi32" ALIAS "DeleteEnhMetaFile"(hEMF AS LONG) AS LONG
    DECLARE FUNCTION CloseEnhMetaFile LIB "gdi32" ALIAS "CloseEnhMetaFile"(hdc AS LONG) AS LONG
    DECLARE FUNCTION GetWindowDC LIB "user32" ALIAS "GetWindowDC"(hWnd AS LONG) AS LONG
    DECLARE FUNCTION GlobalAlloc LIB "kernel32.dll" ALIAS "GlobalAlloc"(flags AS LONG , numBytes AS LONG) AS LONG
    DECLARE FUNCTION GlobalFree LIB "kernel32.dll" ALIAS "GlobalFree"(hMem AS LONG) AS LONG
    DECLARE FUNCTION GlobalLock LIB "kernel32.dll" ALIAS "GlobalLock"(hMem AS LONG) AS LONG
    DECLARE FUNCTION GlobalUnlock LIB "kernel32.dll" ALIAS "GlobalUnlock"(hMem AS LONG) AS LONG
    DECLARE FUNCTION OpenPrinter LIB "winspool.drv" ALIAS "OpenPrinterA"(printerName AS STRING , Handle AS LONG , pDefault AS LONG) AS LONG
    DECLARE FUNCTION StartDoc LIB "gdi32.dll" ALIAS "StartDocA"(hdc AS LONG , DocInf AS LONG) AS LONG
    DECLARE FUNCTION AbortDoc LIB "gdi32.dll" ALIAS "AbortDoc"(hdc AS LONG) AS LONG
    DECLARE FUNCTION StartPage LIB "gdi32.dll" ALIAS "StartPage"(hdc AS LONG) AS LONG
    DECLARE FUNCTION MulDiv LIB "kernel32.dll" ALIAS "MulDiv"(number AS LONG , numerator AS LONG , denominator AS LONG) AS LONG
    DECLARE FUNCTION CreateFont LIB "gdi32.dll" ALIAS "CreateFontA"(H AS LONG , W AS LONG , E AS LONG , O AS LONG , Weight AS LONG , I AS LONG , U AS LONG , S AS LONG , CharSet AS LONG , OP AS LONG , CP AS LONG , Q AS LONG , PAF AS LONG , Font AS LONG) AS LONG
          'Declare Function SelectObject Lib "gdi32.dll" Alias "SelectObject" (hdc As Long, hObject As Long) As Long
    DECLARE FUNCTION GetBkMode LIB "gdi32.dll" ALIAS "GetBkMode"(hdc AS LONG) AS LONG
    DECLARE FUNCTION SetTextColor LIB "gdi32.dll" ALIAS "SetTextColor"(hdc AS LONG , colour AS LONG) AS LONG
    DECLARE FUNCTION SetBkColor LIB "gdi32.dll" ALIAS "SetBkColor"(hdc AS LONG , colour AS LONG) AS LONG
          'Declare Function DeleteObject Lib "gdi32.dll" Alias "DeleteObject" (hObject As Long) As Long
    DECLARE FUNCTION EndPage LIB "gdi32.dll" ALIAS "EndPage"(hdc AS LONG) AS LONG
    DECLARE FUNCTION EndDoc LIB "gdi32.dll" ALIAS "EndDoc"(hdc AS LONG) AS LONG
    DECLARE FUNCTION ClosePrinter LIB "winspool.drv" ALIAS "ClosePrinter"(hPrinter AS LONG) AS LONG
          'Declare Function GetTextExtentPoint32 Lib "gdi32" Alias "GetTextExtentPoint32A" (hdc As Long, lpsz As string, cbString As Long, lpSize As tagSIze) As Long
    DECLARE FUNCTION GetTextExtentPoint32 LIB "gdi32" ALIAS "GetTextExtentPoint32A"(hdc AS LONG , lpsz AS STRING , cbString AS LONG , lpSize AS LONG) AS LONG
    DECLARE FUNCTION DrawText LIB "user32.dll" ALIAS "DrawTextA"(hdc AS LONG , buf AS LONG , bufsize AS LONG , RECT AS LONG , format AS LONG) AS LONG
    DECLARE FUNCTION CreateBrushIndirect LIB "gdi32.dll" ALIAS "CreateBrushIndirect"(Brush AS LONG) AS LONG
    DECLARE FUNCTION Chord LIB "gdi32.dll" ALIAS "Chord"(hdc AS LONG , Left AS LONG , Top AS LONG , right AS LONG , bottom AS LONG , r1 AS LONG , r2 AS LONG , r3 AS LONG , r4 AS LONG) AS LONG

          'Constants for Printdialog.Style
    $DEFINE PD_ALLPAGES &H0
    $DEFINE PD_SELECTION &H1
    $DEFINE PD_PAGENUMS &H2
    $DEFINE PD_NOSELECTION &H4
    $DEFINE PD_NOPAGENUMS &H8
    $DEFINE PD_COLLATE &H10
    $DEFINE PD_PRINTTOFILE &H20
    $DEFINE PD_PRINTSETUP &H40
    $DEFINE PD_NOWARNING &H80
    $DEFINE PD_RETURNDC &H100
    $DEFINE PD_RETURNIC &H200
    $DEFINE PD_RETURNDEFAULT &H400
    $DEFINE PD_SHOWHELP &H800
    $DEFINE PD_ENABLEPRINTHOOK &H1000
    $DEFINE PD_ENABLESETUPHOOK &H2000
    $DEFINE PD_ENABLEPRINTTEMPLATE &H4000
    $DEFINE PD_ENABLESETUPTEMPLATE &H8000
    $DEFINE PD_ENABLEPRINTTEMPLATEHANDLE &H10000
    $DEFINE PD_ENABLESETUPTEMPLATEHANDLE &H20000
    $DEFINE PD_USEDEVMODECOPIES &H40000
    $DEFINE PD_USEDEVMODECOPIESANDCOLLATE &H40000
    $DEFINE PD_DISABLEPRINTTOFILE &H80000
    $DEFINE PD_HIDEPRINTTOFILE &H100000
    $DEFINE PD_NONETWORKBUTTON &H200000
    $DEFINE PD_Default &H1C0000

          'Constants for TextRect.Format
    $DEFINE DT_TOP &H0
    $DEFINE DT_LEFT &H0
    $DEFINE DT_CENTER &H1
    $DEFINE DT_RIGHT &H2
    $DEFINE DT_VCENTER &H4
    $DEFINE DT_BOTTOM &H8
    $DEFINE DT_WORDBREAK &H10
    $DEFINE DT_SINGLELINE &H20
    $DEFINE DT_EXPANDTABS &H40
    $DEFINE DT_TABSTOP &H80
    $DEFINE DT_NOCLIP &H100
    $DEFINE DT_EXTERNALLEADING &H200
    $DEFINE DT_CALCRECT &H400
    $DEFINE DT_NOPREFIX &H800
    $DEFINE DT_INTERNAL &H1000

          'Brush Styles
    $DEFINE BS_SOLID 0
    $DEFINE BS_NULL 1
    $DEFINE BS_HOLLOW BS_NULL
    $DEFINE BS_HATCHED 2
    $DEFINE BS_PATTERN 3
    $DEFINE BS_INDEXED 4
    $DEFINE BS_DIBPATTERN 5
    $DEFINE BS_DIBPATTERNPT 6
    $DEFINE BS_PATTERN8X8 7
    $DEFINE BS_DIBPATTERN8X8 8

          'Hatch Styles
    $DEFINE HS_HORIZONTAL 0        '-----
    $DEFINE HS_VERTICAL 1        '|||||
    $DEFINE HS_FDIAGONAL 2        '\\\\\
    $DEFINE HS_BDIAGONAL 3        '/////
    $DEFINE HS_CROSS 4        '+++++
    $DEFINE HS_DIAGCROSS 5        'xxxxx
    $DEFINE HS_FDIAGONAL1 6
    $DEFINE HS_BDIAGONAL1 7
    $DEFINE HS_SOLID 8
    $DEFINE HS_DENSE1 9
    $DEFINE HS_DENSE2 10
    $DEFINE HS_DENSE3 11
    $DEFINE HS_DENSE4 12
    $DEFINE HS_DENSE5 13
    $DEFINE HS_DENSE6 14
    $DEFINE HS_DENSE7 15
    $DEFINE HS_DENSE8 16
    $DEFINE HS_NOSHADE 17
    $DEFINE HS_HALFTONE 18
    $DEFINE HS_SOLIDCLR 19
    $DEFINE HS_DITHEREDCLR 20
    $DEFINE HS_SOLIDTEXTCLR 21
    $DEFINE HS_DITHEREDTEXTCLR 22
    $DEFINE HS_SOLIDBKCLR 23
    $DEFINE HS_DITHEREDBKCLR 24
    $DEFINE HS_API_MAX 25

          'Pen Styles
    $DEFINE PS_SOLID 0
    $DEFINE PS_DASH 1        '-------
    $DEFINE PS_DOT 2        '.......
    $DEFINE PS_DASHDOT 3        '_._._._
    $DEFINE PS_DASHDOTDOT 4        '_.._.._
    $DEFINE PS_NULL 5
    $DEFINE PS_INSIDEFRAME 6
    $DEFINE PS_USERSTYLE 7
    $DEFINE PS_ALTERNATE 8
    $DEFINE PS_STYLE_MASK &HF
    $DEFINE PS_ENDCAP_ROUND &H0
    $DEFINE PS_ENDCAP_SQUARE &H100
    $DEFINE PS_ENDCAP_FLAT &H200
    $DEFINE PS_ENDCAP_MASK &HF00
    $DEFINE PS_JOIN_ROUND &H0
    $DEFINE PS_JOIN_BEVEL &H1000
    $DEFINE PS_JOIN_MITER &H2000
    $DEFINE PS_JOIN_MASK &HF000
    $DEFINE PS_COSMETIC &H0
    $DEFINE PS_GEOMETRIC &H10000
    $DEFINE PS_TYPE_MASK &HF0000
$ENDIF

DECLARE FUNCTION SystemParameters LIB "user32" ALIAS "SystemParametersInfoA"(uAction AS LONG , uParam AS LONG , lpvParam AS RECT , fuWinIni AS LONG) AS LONG
DIM ScreenRect AS RECT
SUB Screenparameter
    IF SystemParameters(48 , False , ScreenRect , False) = False THEN
        ScreenRect.Top = False
        ScreenRect.Left = False
        ScreenRect.bottom = GetSystemMetrics(17) 'SM_CYFULLSCREEN) 
        ScreenRect.right = GetSystemMetrics(16) 'SM_CXFULLSCREEN)
    END IF
END SUB
Screenparameter


TYPE QPrn EXTENDS QOBJECT
    WITH QPrn
Private :
        PDlg AS PRNTDLG
        PSD AS TPSD
        PrnDefs AS PRNDefaults
        PrnDocinfo AS DocInf
        DevM AS DEVMOD
        Brush AS LOGBRUSH
        Size AS tagSIZE
        FR AS FORMATRANGE
        rtn AS LONG
        prt_Handle AS LONG
        hdcMeta AS LONG        'Variable that holds the Device Context of an Enhanced Meta File image.
        hdcPanel AS LONG        'Variable that holds the Device Context of a child Panel used for displaying an EMF image.
        hEMF  AS LONG        'Variable that holds the handle of an Enhanced Meta File image.
        hWndForm AS LONG        'Variable that holds the handle of the main application's form.
        PageIndex AS LONG        'Variable that holds the page index that is currently being displayed in the child Panel's Device Context.
        SourceHandle AS LONG        'Variable that holds the handle of the richedit-source
        SourceLen AS LONG        'Variable that holds the length of the richedit-text
        bindindex AS LONG
        mywndproc AS LONG
        oldwndproc AS LONG
        PreviewPagecount AS LONG
        zwstr AS STRING
        zwstring AS STRING
        WR    AS RECT        'Used as part of the previewing process (for the dimensions of the preview Form)
        rcBound   AS RECT        'Used as part of the previewing process (for the creation of an EMF image)
        rcChildSize  AS RECT        'Used as part of the previewing process (for the dimensions of the child Panel)
        rcChildMargins AS RECT        'Used as part of the previewing process (for the dimensions of the child Panel)
        lPrntDPIx  AS LONG        
        lPrntDPIy  AS LONG        
        Scrollbar AS QSCROLLBAR

Public :
        PreviewForm AS QFORM        'Window for displaying a preview.
        CtrlPanel  AS QPANEL        'Container for holding the First, Previous, Next, and Last buttons.
        CtrlPrint  AS QcoolBTN        'Button for printing the preview page that is currently being viewed.
        CtrlPage  AS QcoolBTN        'Button for page setup dialog.
        CtrlExit  AS QcoolBTN        'Button for exit previewform.
        CtrlBreak1 AS QPANEL
        CtrlFirst  AS QcoolBTN        'Button for jumping to the First page (of documents with multiple pages).
        CtrlPrevious AS QcoolBTN        'Button for viewing the Previous page (of documents with multiple pages).
        CtrlLabel  AS QLABEL
        CtrlEdit  AS QEDIT
        CtrlOfText AS STRING
        CtrlGoto  AS QcoolBTN
        CtrlNext  AS QcoolBTN        'Button for viewing the Next page (of documents with multiple pages).
        CtrlLast  AS QcoolBTN        'Button for jumping to the Last page (of documents with multiple pages).
        CtrlBreak2 AS QPANEL
        CtrlBig  AS QcoolBTN
        ViewScrollbox AS QSCROLLBOX        'Container for holding the components that are used for displaying a preview page (allows for scrolling).
        ChildPanel AS QPANEL        'Component that will be used for displaying an EMF image "on" (think of it as a... movie screen)
              '(the EMF image represents a document page as it would look if printed).
        ChildCanvas AS QCANVAS        'Component that will be used for displaying the user margins on the child Panel
        CancelKey AS boolean         'Cancel the Preview by pressing Esc allowed ?

        jobID AS LONG
        ParentHandle AS LONG
        Printername AS STRING PROPERTY SET SetPrintername
        DefaultPrinter AS STRING
        Title AS STRING
        Font AS QFONT
        Header AS STRING
        HeaderMiddle AS STRING
        HeaderRight AS STRING
        Footer AS STRING
        FooterMiddle AS STRING
        FooterRight AS STRING
        DisablePrinter AS boolean
        DisablePaper AS boolean
        DisableOrient AS boolean
        DisableMargins AS boolean
        Orientation AS Boolean PROPERTY SET SetOrientation
        PaperSize AS WORD PROPERTY SET SetPaperSize
        PageWidth AS LONG PROPERTY SET SetPageWidth
        PageHeight AS LONG PROPERTY SET SetPageHeight
        MeterInch as LONG
        PageWidthPix AS LONG
        PageHeightPix AS LONG
        MarginLeftPix AS LONG
        MarginTopPix AS LONG
        MarginRightPix AS LONG
        MarginBottomPix AS LONG
        FromPage AS LONG
        ToPage AS LONG
        MaxPages AS LONG
        Copies AS SHORT PROPERTY SET SetCopies
        DefaultSource AS SHORT PROPERTY SET SetDefaultSource
        PrintQuality AS SHORT PROPERTY SET SetPrintQuality
        PrintColor AS SHORT PROPERTY SET SetPrintColor
        Duplex AS SHORT PROPERTY SET SetDuplex
        Collate AS boolean PROPERTY SET SetCollate
        MarginLeft AS LONG PROPERTY SET SetMarginLeft
        MarginTop AS LONG PROPERTY SET SetMarginTop
        MarginRight AS LONG PROPERTY SET SetMarginRight
        MarginBottom AS LONG PROPERTY SET SetMarginBottom
        prt_DC AS LONG
        PenStyle AS LONG
        PenSize AS LONG
        BrushStyle AS LONG
        BrushHatch AS LONG
        CopyMode AS LONG
        BkMode AS LONG

        PROPERTY SET SetPrintername(value AS STRING)
            .Printername = value
            .DevM.dmDeviceName = LEFT$(.PrinterName + STRING$(0 , 32) , 31) + CHR$(0)
            .prt_DC = 0
        END PROPERTY

        PROPERTY SET SetOrientation(value AS boolean)
            .Orientation = value        '0 = Portait, 1 = Landscape
            .DevM.dmOrientation = IIF(.Orientation > 0 , 2 , 1)       'either DMORIENT_PORTRAIT (1) or DMORIENT_LANDSCAPE (2)
            IF .Orientation > 0 THEN .DevM.dmFields = DM_ORIENTATION OR .DevM.dmFields
        END PROPERTY

        PROPERTY SET SetPaperSize(value AS WORD)
            IF value > 0 THEN
                .PaperSize = value        'A3 = 8 , A4 = 9 , A5 = 11 , etc ...
                IF (.DevM.dmFields AND DM_PAPERSIZE) = 0 THEN .DevM.dmFields = DM_PAPERSIZE OR .DevM.dmFields
                .DevM.dmPaperSize = .PaperSize
                .prt_DC = 0
            END IF
        END PROPERTY

        PROPERTY SET SetPageWidth(value AS LONG)
            .PageWidth = value
            .DevM.dmPaperWidth = .PageWidth * 10
        END PROPERTY

        PROPERTY SET SetPageHeight(value AS LONG)
            .PageHeight = value
            .DevM.dmPaperlength = .PageHeight * 10
        END PROPERTY

        PROPERTY SET SetCopies(value AS SHORT)
            .Copies = IIF(value > 0 , value , 1)
            .DevM.dmCopies = .Copies
            IF (.DevM.dmFields AND DM_Copies) = 0 THEN .DevM.dmFields = .DevM.dmFields OR dm_copies
        END PROPERTY

        PROPERTY SET SetDefaultSource(value AS SHORT)
            IF value <> 0 THEN
                .DefaultSource = value
                IF (.DevM.dmFields AND DM_DEFAULTSOURCE) = 0 THEN .DevM.dmFields = DM_DEFAULTSOURCE OR .DevM.dmFields
                .DevM.dmDefaultSource = .DefaultSource
            END IF
        END PROPERTY

        PROPERTY SET SetPrintQuality(value AS SHORT)
            IF value <> 0 THEN
                .PrintQuality = value        'DMRES_DRAFT = (-1), DMRES_HIGH = (-4), DMRES_LOW = (-2), DMRES_MEDIUM = (-3)
                .DevM.dmPrintQuality = .PrintQuality        '>0 =DPI
            END IF
        END PROPERTY

        PROPERTY SET SetPrintColor(value AS SHORT)
            IF value > 0 AND value < 3 THEN
                .PrintColor = value        '1 = False, 2= True
                .DevM.dmColor = .PrintColor
            END IF
        END PROPERTY

        PROPERTY SET SetDuplex(value AS SHORT)
            IF value > 0 AND Value < 4 THEN
                .Duplex = value        '1 = DUPLEX = OFF, 2 = Vertical, 3 = Horizontal
                .DevM.dmDuplex = .Duplex
            END IF
        END PROPERTY

        PROPERTY SET SetCollate(value AS Boolean)
            .Collate = value
            .DevM.dmCollate = .Collate
        END PROPERTY

        PROPERTY SET SetMarginLeft(value AS LONG)
            .PSD.rtMarginLeft = value * 100
            if  .PSD.rtMarginLeft < .PSD.rtMinMarginLeft then .PSD.rtMarginLeft = .PSD.rtMinMarginLeft
            .MarginLeft = round(.PSD.rtMarginLeft / 100)
        END PROPERTY

        PROPERTY SET SetMarginTop(value AS LONG)
            .PSD.rtMarginTop = value * 100
            if  .PSD.rtMarginTop < .PSD.rtMinMarginTop then .PSD.rtMarginTop = .PSD.rtMinMarginTop
            .MarginTop = round(.PSD.rtMarginTop / 100)
        END PROPERTY

        PROPERTY SET SetMarginRight(value AS LONG)
            .PSD.rtMarginRight = value * 100
            if  .PSD.rtMarginRight < .PSD.rtMinMarginRight then .PSD.rtMarginRight = .PSD.rtMinMarginRight
            .MarginRight = round(.PSD.rtMarginRight / 100)
        END PROPERTY

        PROPERTY SET SetMarginBottom(value AS LONG)
            .PSD.rtMarginBottom = value * 100
            if  .PSD.rtMarginBottom < .PSD.rtMinMarginBottom then .PSD.rtMarginBottom = .PSD.rtMinMarginBottom
            .MarginBottom = round(.PSD.rtMarginBottom / 100)
        END PROPERTY

        SUB SetPix
            IF .prt_dc <> 0 THEN
                .PagewidthPix = GetDeviceCaps(.prt_DC , 110) '8)       '110)
                .PageHeightPix = GetDeviceCaps(.prt_DC , 111) '10)       '111)
                .lPrntDPIx  = GetDeviceCaps(.prt_DC , &H58)        
                .lPrntDPIy  = GetDeviceCaps(.prt_DC , &H5A)        
                .Pagewidth = round(GetDeviceCaps(.prt_DC , 110) / .lPrntDPIx * 25.4) '23.622)
                .Pageheight = round(GetDeviceCaps(.prt_DC , 111) / .lPrntDPIy * 25.4) '23.622)
                .MarginLeftPix = .PageWidthPix * .MarginLeft / .PageWidth
                .MarginTopPix = .PageHeightPix * .MarginTop / .PageHeight
                .MarginRightPix = .PageWidthPix - (.PageWidthPix * .MarginRight / .PageWidth)
                .MarginBottomPix = .PageHeightPix - (.PageHeightPix * .MarginBottom / .PageHeight)
            END IF
        END SUB

        FUNCTION PageDialog AS boolean
            DEFWORD FWord
            Result = False
            .PSD.lStructSize = SIZEOF(QPrn.PSD)
            .PSD.hWndOwner = .ParentHandle        'Application.Handle
            .PSD.Flags = PSD_MARGINS OR PSD_MINMARGINS  OR .MeterInch
            IF .DisablePrinter THEN .PSD.Flags = .PSD.Flags + PSD_DISABLEPRINTER
            IF .DisablePaper THEN .PSD.Flags = .PSD.Flags + PSD_DISABLEPAPER
            IF .DisableOrient THEN .PSD.Flags = .PSD.Flags + PSD_DISABLEORIENTATION
            IF .DisableMargins THEN .PSD.Flags = .PSD.Flags + PSD_DISABLEMARGINS
            DEFSTR s = LEFT$(.PrinterName + STRING$(0 , 32) , 31) + CHR$(0)
            .DevM.dmDeviceName = s
            DEFLNG dm_Memory = GlobalAlloc(&H0040 , 300)
            IF dm_Memory <> 0 THEN
                DEFLNG dm_Default = GlobalLock(dm_Memory)
                IF dm_Default <> 0 THEN
                    DEFLNG dmLock = dm_Default
                    CopyMemory dm_Default , UDTPTR(QPrn.Devm) , SIZEOF(QPrn.DevM)
                    .PSD.hDevMode = dm_Default
                    .PSD.hDevNames = dm_Default + 240
                    FWord = 20
                    CopyMemory dm_Default + 242 , VARPTR(FWord) , 2
                    CopyMemory dm_Default + 260 , VARPTR(s) , 32
                          'generate the main dialog box
                    IF PageSetupDlgA(QPrn.PSD) THEN
                        dm_Default = .PSD.hDevMode
                        IF dm_Default <> 0 THEN
                            CopyMemory UDTPTR(QPrn.Devm) , dm_Default , SIZEOF(QPrn.DevM)
                            .PaperSize = .DevM.dmPaperSize
                            if  .PSD.rtMarginLeft < .PSD.rtMinMarginLeft then .PSD.rtMarginLeft=.PSD.rtMinMarginLeft
                            if  .PSD.rtMarginTop < .PSD.rtMinMarginTop then .PSD.rtMarginTop = .PSD.rtMinMarginTop
                            if  .PSD.rtMarginRight < .PSD.rtMinMarginRight then .PSD.rtMarginRight = .PSD.rtMinMarginRight
                            if  .PSD.rtMarginBottom < .PSD.rtMinMarginBottom then .PSD.rtMarginBottom = .PSD.rtMinMarginBottom
                            if .MeterInch = PSD_INHUNDREDTHSOFMILLIMETERS then
                                .PageWidth = ROUND(.PSD.ptPaperSizeX / 100)
                                .PageHeight = ROUND(.PSD.ptPaperSizeY / 100)
                                .MarginLeft = round(.PSD.rtMarginLeft / 100)
                                .MarginTop = round(.PSD.rtMarginTop / 100)
                                .MarginRight = round(.PSD.rtMarginRight / 100)
                                .MarginBottom = round(.PSD.rtMarginBottom / 100)
                            else
                                .PageWidth = ROUND(.PSD.ptPaperSizeX / 39.367)
                                .PageHeight = ROUND(.PSD.ptPaperSizeY / 39.367)
                                .MarginLeft = round(.PSD.rtMarginLeft / 39.367)
                                .MarginTop = round(.PSD.rtMarginTop / 39.367)
                                .MarginRight = round(.PSD.rtMarginRight / 39.367)
                                .MarginBottom = round(.PSD.rtMarginBottom / 39.367)
                            end if
                            .Orientation = IIF(.PageWidth > .PageHeight , True , False)
                            .DevM.dmOrientation = IIF(.Orientation > 0 , 2 , 1)       'either DMORIENT_PORTRAIT (1) or DMORIENT_LANDSCAPE (2)
                            .DevM.dmFields = DM_ORIENTATION OR .DevM.dmFields
                            .DefaultSource = .DevM.dmDefaultSource
                            .SetPix
                            Result = True
                            .PDlg.hDevMode = UDTPTR(QPrn.DevM)
                        END IF
                    END IF
                    GlobalUnlock(dmLock)
                END IF
                GlobalFree(dm_Memory)
            END IF
        END FUNCTION

        FUNCTION PrintDialog(Style AS LONG) AS LONG
            DEFWORD FWord
            DEFLNG ttt1 = 0
            Result = False
            .PDlg.lStructSize = SIZEOF(QPrn.PDlg)
            .PDlg.hInstance = Application.hInstance
            .PDlg.hWndOwner = .ParentHandle
            .PDlg.Flags = IIF(Style = 0 , PD_Default , Style) OR PD_RETURNDC
            .DevM.dmOrientation = IIF(.Orientation > 0 , 2 , 1)       'either DMORIENT_PORTRAIT (1) or DMORIENT_LANDSCAPE (2)
            .DevM.dmCopies = .Copies
            .Pdlg.nCopies = .Copies
            .DevM.dmDefaultSource = .DefaultSource
            .DevM.dmPrintQuality = .PrintQuality
            .DevM.dmColor = .PrintColor
            .DevM.dmDuplex = .Duplex
            .DevM.dmCollate = .Collate
            .DevM.dmPaperSize = .PaperSize
            .DevM.dmPaperWidth = .PageWidth * 10
            .DevM.dmPaperlength = .PageHeight * 10
            .PDlg.nFrompage = .FromPage
            .PDlg.nminpage = .FromPage
            .PDlg.nTopage = .ToPage
            .PDlg.nmaxpage = .ToPage
            DEFSTR s = LEFT$(.PrinterName + STRING$(0 , 32) , 31) + CHR$(0)
            .DevM.dmDeviceName = s
            DEFLNG dm_Memory = GlobalAlloc(&H0040 , 300)
            IF dm_Memory <> 0 THEN
                DEFLNG dm_Default = GlobalLock(dm_Memory)
                IF dm_Default <> 0 THEN
                    DEFLNG dmLock = dm_Default
                    CopyMemory dm_Default , UDTPTR(QPrn.Devm) , SIZEOF(QPrn.DevM)
                    .PDlg.hDevMode = dm_Default
                    .PDlg.hDevNames = dm_Default + 240
                    FWord = 20
                    CopyMemory dm_Default + 242 , VARPTR(FWord) , 2
                    CopyMemory dm_Default + 260 , VARPTR(s) , 32
                    ttt1 = PrintDlgA(QPrn.PDlg)
                          'showmessage("ttt1="+str$(ttt1))
                    DOEVENTS
                    IF ttt1 THEN
                        dm_Default = QPrn.PDlg.hDevMode
                        IF dm_Default <> 0 THEN
                            CopyMemory UDTPTR(QPrn.Devm) , dm_Default , SIZEOF(QPrn.DevM)
                            .Printername = LEFT$(.DevM.dmDeviceName , INSTR(.DevM.dmDeviceName + CHR$(0) , CHR$(0)) - 1)
                            .Orientation = IIF(.DevM.dmOrientation = 1 , False , True)
                            .PaperSize = .DevM.dmPaperSize
                            IF .Orientation THEN
                                .PageHeight = ROUND(.DevM.dmPaperWidth / 10)
                                .PageWidth = ROUND(.DevM.dmPaperlength / 10)
                            ELSE
                                .PageWidth = ROUND(.DevM.dmPaperWidth / 10)
                                .PageHeight = ROUND(.DevM.dmPaperlength / 10)
                            END IF
                            .DefaultSource = .DevM.dmDefaultSource
                            .PrintQuality = .DevM.dmPrintQuality
                            .PrintColor = .DevM.dmColor
                            .Duplex = .DevM.dmDuplex
                            .Collate = .DevM.dmCollate
                            .Copies = IIF(.Collate = 0 , .DevM.dmcopies , 1)
                            .FromPage = 1
                            .ToPage = .Maxpages
                            IF (.PDlg.flags AND PD_Pagenums) = PD_Pagenums THEN
                                .FromPage = .PDlg.nFromPage
                                .ToPage = .PDlg.nToPage
                                Result = PD_Pagenums
                            ELSEIF (.PDlg.flags AND PD_Selection) = PD_Selection THEN
                                Result = PD_Selection
                            ELSE
                                Result = 3
                            END IF
                            .prt_Dc = .PDlg.hDc
                            .SetPix
                        END IF
                    END IF
                    GlobalUnlock(dmLock)
                END IF
                GlobalFree(dm_Memory)
            END IF
        END FUNCTION

        FUNCTION Initialise AS boolean
            IF .prt_dc <> 0 THEN
                .rtn = DeleteDC(.prt_DC)
                .prt_DC = 0
            END IF
            Result = False
            MEMSET(QPrn.DevM , 0 , SIZEOF(QPrn.DevM))
            MEMSET(QPrn.PSD , 0 , SIZEOF(QPrn.PSD))
            .PSD.lStructSize = SIZEOF(QPrn.PSD)
            .PSD.hWndOwner = .ParentHandle
            .PSD.Flags = PSD_RETURNDEFAULT
            IF PageSetupDlgA(QPrn.PSD) THEN
                Result = True
                if (.PSD.Flags and PSD_INHUNDREDTHSOFMILLIMETERS) = PSD_INHUNDREDTHSOFMILLIMETERS then
                    .MeterInch = PSD_INHUNDREDTHSOFMILLIMETERS
                    .PageWidth = ROUND(.PSD.ptPaperSizeX / 100)
                    .PageHeight = ROUND(.PSD.ptPaperSizeY / 100)
                    .MarginLeft = round(.PSD.rtMarginLeft / 100)
                    .MarginTop = round(.PSD.rtMarginTop / 100)
                    .MarginRight = round(.PSD.rtMarginRight / 100)
                    .MarginBottom = round(.PSD.rtMarginBottom / 100)
                else
                    .MeterInch = PSD_INTHOUSANDTHSOFINCHES 
                    .PageWidth = ROUND(.PSD.ptPaperSizeX / 39.367)
                    .PageHeight = ROUND(.PSD.ptPaperSizeY / 39.367)
                    .MarginLeft = round(.PSD.rtMarginLeft / 39.367)
                    .MarginTop = round(.PSD.rtMarginTop / 39.367)
                    .MarginRight = round(.PSD.rtMarginRight / 39.367)
                    .MarginBottom = round(.PSD.rtMarginBottom / 39.367)
                end if                
                .Orientation = IIF(.PageWidth > .PageHeight , True , False)
            END IF
            MEMSET(QPrn.PDlg , 0 , SIZEOF(QPrn.PDlg))
            .PDlg.lStructSize = SIZEOF(QPrn.PDlg)
            .PDlg.Flags = PD_RETURNDEFAULT OR PD_RETURNDC
            .PDlg.hWndOwner = .ParentHandle
            .PDlg.hDevMode = UDTPTR(QPrn.DevM)
            IF PrintDlgA(QPrn.PDlg) <> 0 THEN
                IF .PDlg.hDevMode <> 0 THEN
                    CopyMemory UDTPTR(QPrn.Devm) , QPrn.PDlg.hDevMode , SIZEOF(QPrn.DevM)
                    .Printername = LEFT$(.DevM.dmDeviceName , INSTR(.DevM.dmDeviceName + CHR$(0) , CHR$(0)) - 1)
                    .DefaultPrinter = .PrinterName
                    .PaperSize = .DevM.dmPaperSize
                    .Copies = .DevM.dmcopies
                    .DefaultSource = .DevM.dmDefaultSource
                    .PrintQuality = .DevM.dmPrintQuality
                    .PrintColor = .DevM.dmColor
                    .Duplex = .DevM.dmDuplex
                    .Collate = .DevM.dmCollate
                    .prt_Dc = .PDlg.hDc
                    Result = True
                END IF
            END IF
            .SetPix
        END FUNCTION

        FUNCTION Textheight(t AS STRING) AS LONG
            Result = 1.2 * .Font.Size
            IF .prt_dc <> 0 THEN
                DEFSTR s = t + CHR$(0) , FW_Name = .Font.Name
                DEFLNG hsize = -MulDiv(.Font.Size , GetDeviceCaps(.prt_DC , 88) , 72) , FW_Bold = IIF(.Font.bold = True , 700 , 400)
                .rtn = CreateFont(hsize , 0 , 0 , 0 , FW_Bold , .Font.ITALIC , .Font.UNDERLINE , .Font.STRIKEOUT , .Font.CHARSET , 0 , 0 , 0 , 0 , VARPTR(FW_Name))
                IF .rtn <> 0 THEN SelectObject(.prt_DC , .rtn)
                IF GetTextExtentPoint32(.prt_DC , s , LEN(s) - 1 , udtptr(QPrn.Size)) <> 0 THEN Result = .Size.cy
                IF .rtn <> 0 THEN DeleteObject(.rtn)
            END IF
        END FUNCTION

        FUNCTION TextWidth(t AS STRING) AS LONG
            Result = 0
            IF .prt_dc <> 0 THEN
                DEFSTR s = t + CHR$(0) , FW_Name = .Font.Name
                DEFLNG hsize = -MulDiv(.Font.Size , GetDeviceCaps(.prt_DC , 88) , 72) , FW_Bold = IIF(.Font.bold = True , 700 , 400)
                .rtn = CreateFont(hsize , 0 , 0 , 0 , FW_Bold , .Font.ITALIC , .Font.UNDERLINE , .Font.STRIKEOUT , .Font.CHARSET , 0 , 0 , 0 , 0 , VARPTR(FW_Name))
                IF .rtn <> 0 THEN SelectObject(.prt_DC , .rtn)
                IF GetTextExtentPoint32(.prt_DC , s , LEN(s) - 1 , udtptr(QPrn.Size)) <> 0 THEN Result = .Size.cx
                IF .rtn <> 0 THEN DeleteObject(.rtn)
            END IF
        END FUNCTION

        SUB MakeNewDC
            IF .prt_dc <> 0 THEN DeleteDC(.prt_DC)
            .Prndefs.pDevMode = UDTPTR(QPrn.DevM)
            .Prndefs.Desiredaccess = PRINTER_ACCESS_USE        'PRINTER_ALL_ACCESS '
            .rtn = OpenPrinter(.PrinterName , VARPTR(QPrn.prt_Handle) , UdtPtr(QPrn.Prndefs))
            IF .rtn <> 0 THEN .prt_DC = CreateDCA("" , .PrinterName , "" , UDTPTR(QPrn.DevM))
            IF .prt_DC = 0 THEN
                .prt_Handle = 0
            ELSE
                .SetPix
            END IF
        END SUB

        FUNCTION BeginDoc AS boolean
            IF .prt_DC = 0 THEN .MakeNewDC
            IF .prt_dc <> 0 THEN
                MEMSET(QPrn.prndocinfo , 0 , SIZEOF(QPrn.prndocinfo))
                .prndocinfo.cbSize = SIZEOF(QPrn.prndocinfo)
                .prndocinfo.lpszDocName = VARPTR(QPrn.Title)
                .jobID = StartDoc(.prt_DC , udtPtr(QPrn.prndocinfo))
                IF .jobID > 0 THEN
                    .rtn = StartPage(.prt_DC)
                    IF .rtn > 0 THEN result = True
                END IF
            END IF
        END FUNCTION

        FUNCTION Abort AS boolean
            Result = False
            IF .prt_DC <> 0 THEN
                IF AbortDoc(.prt_DC) > 0 THEN Result = True
                DeleteDC(.prt_DC)
                .prt_DC = 0
                .jobID = 0
            END IF
            IF .prt_Handle <> 0 THEN
                .rtn = ClosePrinter(.prt_Handle)
                .prt_Handle = 0
            END IF
        END FUNCTION

        FUNCTION TextOut(x AS INTEGER , y AS INTEGER , Text AS STRING , Fc AS INTEGER , Bc AS INTEGER) AS boolean
            Result = False
            IF .prt_dc <> 0 THEN
                DEFSTR s = Text + CHR$(0) , FW_Name = .Font.Name
                DEFLNG hsize = -MulDiv(.Font.Size , GetDeviceCaps(.prt_DC , 88) , 72) , FW_Bold = IIF(.Font.bold = True , 700 , 400)
                .rtn = CreateFont(hsize , 0 , 0 , 0 , FW_Bold , .Font.ITALIC , .Font.UNDERLINE , .Font.STRIKEOUT , .Font.CHARSET , 0 , 0 , 0 , 0 , VARPTR(FW_Name))
                IF .rtn <> 0 THEN SelectObject(.prt_DC , .rtn)
                IF GetBkMode(.prt_DC) <> .BkMode THEN SetBkMode(.prt_DC , .BkMode)
                SetBkColor(.prt_DC , IIF(Bc = -1 , clWhite , Bc))
                SetTextColor(.prt_DC , IIF(Fc = -1 , .Font.Color , Fc))
                IF TextOutA(.prt_DC , x , y , VARPTR(s) , LEN(s) - 1) <> 0 THEN Result = True
                IF .rtn <> 0 THEN DeleteObject(.rtn)
            END IF
        END FUNCTION

        FUNCTION TextRect(Left AS LONG , Top AS LONG , right AS LONG , bottom AS LONG , Text AS STRING , format AS LONG , Fc AS INTEGER , Bc AS INTEGER) AS boolean
            Result = False
            IF .prt_dc <> 0 THEN
                DEFSTR s = Text + CHR$(0) , FW_Name = .Font.Name
                DEFLNG hsize = -MulDiv(.Font.Size , GetDeviceCaps(.prt_DC , 88) , 72) , FW_Bold = IIF(.Font.bold = True , 700 , 400)
                .rtn = CreateFont(hsize , 0 , 0 , 0 , FW_Bold , .Font.ITALIC , .Font.UNDERLINE , .Font.STRIKEOUT , .Font.CHARSET , 0 , 0 , 0 , 0 , VARPTR(FW_Name))
                IF .rtn <> 0 THEN SelectObject(.prt_DC , .rtn)
                IF GetBkMode(.prt_DC) <> .BkMode THEN SetBkMode(.prt_DC , .BkMode)
                SetBkColor(.prt_DC , IIF(Bc = -1 , clWhite , Bc))
                SetTextColor(.prt_DC , IIF(Fc = -1 , .Font.Color , Fc))
                DIM dtRect AS RECT
                dtRect.Top = Top
                dtRect.Left = Left
                dtRect.right = right
                dtRect.bottom = bottom
                IF DrawText(.prt_DC , VARPTR(s) , LEN(s) - 1 , udtptr(dtRect) , format) <> 0 THEN Result = True
                IF .rtn <> 0 THEN DeleteObject(.rtn)
            END IF
        END FUNCTION

        FUNCTION Line(X1 AS LONG , Y1 AS LONG , X2 AS LONG , Y2 AS LONG , Fc AS INTEGER) AS boolean
            Result = False
            IF .prt_dc <> 0 THEN
                .rtn = CreatePen(.Penstyle , IIF((.Penstyle > 0) AND (.Penstyle < 5) , 1 , .PenSize) , Fc)
                IF .rtn <> 0 THEN SelectObject(.prt_DC , .rtn)
                IF MoveToEx(.prt_DC , x1 , y1 , 0) <> 0 THEN
                    .Brush.lbStyle = .BrushStyle
                    .Brush.lbColor = clWhite
                    .Brush.lbHatch = .BrushHatch
                    DEFLNG hBrush = CreateBrushIndirect(udtptr(QPrn.Brush))
                    IF hBrush <> 0 THEN SelectObject(.prt_DC , hBrush)
                    IF LineTo(.prt_DC , x2 , y2) <> 0 THEN Result = True
                    IF hBrush <> 0 THEN DeleteObject(hBrush)
                END IF
                IF .rtn <> 0 THEN DeleteObject(.rtn)
            END IF
        END FUNCTION

        FUNCTION Chord(Left AS LONG , Top AS LONG , right AS LONG , bottom AS LONG , r1 AS LONG , r2 AS LONG , r3 AS LONG , r4 AS LONG , Fc AS INTEGER , Fill AS INTEGER) AS boolean
            Result = False
            IF .prt_dc <> 0 THEN
                .rtn = CreatePen(.Penstyle , IIF((.Penstyle > 0) AND (.Penstyle < 5) , 1 , .PenSize) , Fc)
                IF .rtn <> 0 THEN SelectObject(.prt_DC , .rtn)
                .Brush.lbStyle = .BrushStyle
                .Brush.lbColor = IIF(Fill = -1 , clWhite , Fill)
                .Brush.lbHatch = .BrushHatch
                DEFLNG hBrush = CreateBrushIndirect(udtptr(QPrn.Brush))
                IF hBrush <> 0 THEN SelectObject(.prt_DC , hBrush)
                IF Chord(.prt_DC , Left , Top , right , bottom , r1 , r2 , r3 , r4) <> 0 THEN Result = True
                IF hBrush <> 0 THEN DeleteObject(hBrush)
                IF .rtn <> 0 THEN DeleteObject(.rtn)
            END IF
        END FUNCTION


        FUNCTION Circle(Left AS LONG , Top AS LONG , right AS LONG , bottom AS LONG , Fc AS INTEGER , Fill AS INTEGER) AS boolean
            Result = .Chord(Left , Top , right , bottom , 0 , 0 , 0 , 0 , Fc , Fill)
        END FUNCTION

        FUNCTION RoundRect(Left AS LONG , Top AS LONG , right AS LONG , bottom AS LONG , Width AS LONG , Height AS LONG , Fc AS INTEGER , Fill AS INTEGER) AS boolean
            Result = False
            IF .prt_dc <> 0 THEN
                .rtn = CreatePen(.Penstyle , IIF((.Penstyle > 0) AND (.Penstyle < 5) , 1 , .PenSize) , Fc)
                IF .rtn <> 0 THEN SelectObject(.prt_DC , .rtn)
                .Brush.lbStyle = .BrushStyle
                .Brush.lbColor = IIF(Fill = -1 , clWhite , Fill)
                .Brush.lbHatch = .BrushHatch
                DEFLNG hBrush = CreateBrushIndirect(udtptr(QPrn.Brush))
                IF hBrush <> 0 THEN SelectObject(.prt_DC , hBrush)
                IF RoundRect(.prt_DC , Left , Top , right , bottom , Width , Height) <> 0 THEN Result = True
                IF hBrush <> 0 THEN DeleteObject(hBrush)
                IF .rtn <> 0 THEN DeleteObject(.rtn)
            END IF
        END FUNCTION

        FUNCTION FillRect(Left AS LONG , Top AS LONG , right AS LONG , bottom AS LONG , Fc AS INTEGER , Fill AS INTEGER) AS boolean
            Result = .RoundRect(Left , Top , right , bottom , 0 , 0 , Fc , Fill)
        END FUNCTION

        FUNCTION StretchDraw(x AS LONG , y AS LONG , w AS LONG , h AS LONG , source AS QBITMAP) AS boolean
            Result = False
            IF .prt_DC <> 0 THEN
                IF StretchBlt(.prt_DC , x , y , w - x , h - y , source.Handle , 0 , 0 , source.Width , Source.Height , .copyMode) <> 0 THEN Result = True
            END IF
        END FUNCTION

        FUNCTION Draw(x AS LONG , y AS LONG , source AS QBITMAP) AS boolean
            Result = .StretchDraw(x , y , x + Source.Width , y + source.Height , source)
        END FUNCTION

        FUNCTION NewPage AS boolean
            Result = False
            IF .prt_dc <> 0 THEN
                .rtn = EndPage(.prt_DC)
                .rtn = StartPage(.prt_DC)
                IF .rtn > 0 THEN Result = True
            END IF
        END FUNCTION

        FUNCTION RicheditOut(Source AS QRICHEDIT , Mode AS LONG) AS boolean
            Result = False
            IF (.prt_DC = 0) AND ((Mode AND 1) = 0) THEN .MakeNewDC
            IF .prt_DC <> 0 THEN
                MEMSET(QPrn.FR , 0 , SIZEOF(QPrn.FR))
                .FR.hdc = .prt_DC
                .FR.hdcTarget = .prt_DC
                .FR.chrg_cpMin = 0
                .FR.chrg_cpMax = -1
                .FR.rcPage_Left = 1440 / .lPrntDPIx * .MarginLeftPix
                .FR.rc_Left = .FR.rcPage_Left
                .FR.rcPage_Top = 1440 / .lPrntDPIy * .MarginTopPix
                IF LTRIM$(.Header) > "" THEN .FR.rcPage_Top = .FR.rcPage_Top + 3000 / .lPrntDPIy * .Textheight(.Header)
                .FR.rc_Top = .FR.rcPage_Top
                .FR.rcPage_Right = 1440 / .lPrntDPIx * .MarginRightPix
                .FR.rc_Right = .FR.rcPage_Right
                .FR.rcPage_Bottom = 1440 / .lPrntDPIy * .MarginBottomPix
                IF LTRIM$(.Footer) > "" THEN .FR.rcPage_Bottom = .FR.rcPage_Bottom - 3000 / .lPrntDPIy * .Textheight(.Footer)
                .FR.rc_Bottom = .FR.rcPage_Bottom
                DEFLNG iTextOut = IIF((mode AND 2) = 2 , source.SelStart , 0) , Pagecount = 0
                DEFLNG iTextAmt = IIF((mode AND 2) = 2 , source.SelStart + source.SelLength , len(source.Text))
                .FR.chrg_cpMin = iTextOut
                .FR.chrg_cpMax = iTextAmt
                SendMessage(source.Handle , EM_FORMATRANGE , 0 , 0)
                WHILE (iTextOut < iTextAmt)
                    iTextOut = SendMessageAPI(source.Handle , EM_FORMATRANGE , 0 , .FR)
                    IF (Pagecount >= .Frompage - 1) AND (Pagecount <= .Topage - 1) AND ((Mode AND 1) = 1) THEN
                        iTextOut = SendMessageAPI(source.Handle , EM_FORMATRANGE , 1 , .FR)
                        IF LTRIM$(.Header) > "" THEN
                            .zwstring = REPLACESUBSTR$(.Header , "%PAGE%" , STR$(Pagecount + 1))
                            .TextOut(2 + .MarginLeftPix , .MarginTopPix + 2 , REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount)) , -1 , -1)
                        END IF
                        IF LTRIM$(.HeaderMiddle) > "" THEN
                            .zwstring = REPLACESUBSTR$(.HeaderMiddle , "%PAGE%" , STR$(Pagecount + 1))
                            .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                            .TextOut((.PagewidthPix - .TextWidth(.zwstring)) / 2 , .MarginTopPix + 2 , .zwstring , -1 , -1)
                        END IF
                        IF LTRIM$(.HeaderRight) > "" THEN
                            .zwstring = REPLACESUBSTR$(.HeaderRight , "%PAGE%" , STR$(Pagecount + 1))
                            .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                            .TextOut(.MarginRightPix - .TextWidth(.zwstring) - 10 , .MarginTopPix + 2 , .zwstring , -1 , -1)
                        END IF
                        IF LTRIM$(.Footer) > "" THEN
                            .zwstring = REPLACESUBSTR$(.Footer , "%PAGE%" , STR$(Pagecount + 1))
                            .TextOut(2 + .MarginLeftPix , .MarginBottomPix - .Textheight(.zwstring) *1.4 , REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount)) , -1 , -1)
                        END IF
                        IF LTRIM$(.FooterMiddle) > "" THEN
                            .zwstring = REPLACESUBSTR$(.FooterMiddle , "%PAGE%" , STR$(Pagecount + 1))
                            .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                            .TextOut((.PagewidthPix - .TextWidth(.zwstring)) / 2 , .MarginBottomPix - .Textheight(.zwstring)*1.4 , .zwstring , -1 , -1)
                        END IF
                        IF LTRIM$(.zwstring) > "" THEN
                            .zwstring = REPLACESUBSTR$(.FooterRight , "%PAGE%" , STR$(Pagecount + 1))
                            .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                            .TextOut(.MarginRightPix - .TextWidth(.zwstring) - 10 , .MarginBottomPix - .Textheight(.zwstring)*1.4 , .zwstring , -1 , -1)
                        END IF
                    END IF
                    IF (iTextOut < iTextAmt) THEN
                        IF (Pagecount >= .Frompage - 1) AND (Pagecount < .Topage - 1) AND ((Mode AND 1) = 1) THEN .NewPage
                        Pagecount = Pagecount + 1
                        .FR.chrg_cpMin = iTextOut
                    END IF
                    Result = True
                WEND
                      'SendMessage(source.Handle , EM_FORMATRANGE , 1 , 0)
                IF (mode AND 1) = 0 THEN
                    .FromPage = 1
                    .ToPage = Pagecount + 1
                    .PreviewPagecount = .ToPage
                END IF
                SendMessage(source.Handle , EM_FORMATRANGE , 0 , 0)
            END IF
        END FUNCTION

        FUNCTION EndDoc AS boolean
            Result = False
            IF .prt_dc <> 0 THEN
                .rtn = EndPage(.prt_DC)
                IF .rtn > 0 THEN
                    .rtn = EndDoc(.prt_DC)
                    IF .rtn > 0 THEN Result = True
                END IF
                .rtn = DeleteDC(.prt_DC)
                .prt_DC = 0
                .jobID = 0
            END IF
            IF .prt_Handle <> 0 THEN
                .rtn = ClosePrinter(.prt_Handle)
                .prt_Handle = 0
            END IF
            .MakeNewDC
        END FUNCTION

Private :
        SUB ChildCanvas_OnPaint()
            IF (.hdcPanel = 0) AND (.hEMF = 0) THEN
                .ChildCanvas.FillRect(0 , 0 , .ChildCanvas.Width , .ChildCanvas.Height , RGB(205 , 205 , 205))
            ELSE
                .ChildCanvas.FillRect(0 , 0 , .ChildCanvas.Width , .ChildCanvas.Height , RGB(255 , 255 , 255))
                PlayEnhMetaFile(.hdcPanel , .hEMF , .rcChildSize)
                .ChildCanvas.Line(.rcChildMargins.Left , .rcChildMargins.Top , .rcChildMargins.right , .rcChildMargins.Top , RGB(205 , 205 , 205))
                .ChildCanvas.Line(.rcChildMargins.Right , .rcChildMargins.Top , .rcChildMargins.Right , .rcChildMargins.Bottom , RGB(205 , 205 , 205))
                .ChildCanvas.Line(.rcChildMargins.Right , .rcChildMargins.Bottom , .rcChildMargins.Left , .rcChildMargins.Bottom , RGB(205 , 205 , 205))
                .ChildCanvas.Line(.rcChildMargins.Left , .rcChildMargins.Bottom , .rcChildMargins.Left , .rcChildMargins.Top , RGB(205 , 205 , 205))
            END IF
        END SUB

        FUNCTION PreTextOut(x AS INTEGER , y AS INTEGER , Text AS STRING , Fc AS INTEGER , Bc AS INTEGER) AS boolean
            Result = False
            IF .hdcMeta <> 0 THEN
                DEFSTR s = Text + CHR$(0) , FW_Name = .Font.Name
                DEFLNG hsize = -MulDiv(.Font.Size , GetDeviceCaps(.hdcMeta , 88) , 72) , FW_Bold = IIF(.Font.bold = True , 700 , 400) 
                .rtn = CreateFont(hsize , 0 , 0 , 0 , FW_Bold , .Font.ITALIC , .Font.UNDERLINE , .Font.STRIKEOUT , .Font.CHARSET , 0 , 0 , 0 , 0 , VARPTR(FW_Name))
                IF .rtn <> 0 THEN SelectObject(.hdcMeta , .rtn)
                IF GetBkMode(.hdcMeta) <> .BkMode THEN SetBkMode(.hdcMeta , .BkMode)
                SetBkColor(.hdcMeta , IIF(Bc = -1 , clWhite , Bc))
                SetTextColor(.hdcMeta , IIF(Fc = -1 , .Font.Color , Fc))
                IF TextOutA(.hdcMeta , x , y , VARPTR(s) , len(s) - 1) <> 0 THEN Result = True
                IF .rtn <> 0 THEN DeleteObject(.rtn)
            END IF
        END FUNCTION

        SUB GeneratePage(index AS LONG)
            IF .hdcMeta THEN DeleteDC(.hdcMeta)
            .hdcMeta = 0
            IF .hEMF THEN DeleteEnhMetaFile(.hEMF)
            .hEMF = 0
            IF .prt_DC <> 0 THEN
                .hdcMeta = CreateEnhMetaFile(.prt_DC , 0 , .rcBound , 0)
                IF .hdcMeta THEN
                    MEMSET(QPrn.FR , 0 , SIZEOF(QPrn.FR))
                    .FR.hdc   = .hdcMeta
                    .FR.hdcTarget  = .hdcMeta
                    .FR.chrg_cpMin = 0
                    .FR.chrg_cpMax = -1
                    .FR.rcPage_Left = 1440 / .lPrntDPIx * .MarginLeftPix
                    .FR.rc_Left = .FR.rcPage_Left
                    .FR.rcPage_Top = 1440 / .lPrntDPIy * .MarginTopPix 
                    IF LTRIM$(.Header) > "" THEN .FR.rcPage_Top = .FR.rcPage_Top +  3000 / .lPrntDPIy * .Textheight(.Header)
                    .FR.rc_Top = .FR.rcPage_Top
                    .FR.rcPage_Right = 1440 / .lPrntDPIx * .MarginRightPix 
                    .FR.rc_Right = .FR.rcPage_Right
                    .FR.rcPage_Bottom = 1440 / .lPrntDPIy * .MarginBottomPix
                    IF LTRIM$(.Footer) > "" THEN .FR.rcPage_Bottom = .FR.rcPage_Bottom -  3000 / .lPrntDPIy * .Textheight(.Footer)
                    .FR.rc_Bottom = .FR.rcPage_Bottom

                    DEFLNG iTextOut = 0 , Pagefound = 0        ', iTextAmt = len(.sourceText)
                    .PreviewPagecount = 0
                    .FR.chrg_cpMin = iTextOut
                    .FR.chrg_cpMax = .Sourcelen        'iTextAmt
                    SendMessage(.sourceHandle , EM_FORMATRANGE , 0 , 0)
                    WHILE (iTextOut < .Sourcelen)       'iTextAmt)
                        iTextOut = SendMessageAPI(.sourceHandle , EM_FORMATRANGE , 0 , .FR)
                        IF .PreviewPagecount = index THEN
                            iTextOut = SendMessageAPI(.sourceHandle , EM_FORMATRANGE , 1 , .FR)
                            Pagefound = .PreviewPagecount
                        END IF
                        IF (iTextOut < .Sourcelen) THEN
                            .PreviewPagecount = .PreviewPagecount + 1
                            .FR.chrg_cpMin = iTextOut
                        END IF
                    WEND
                    SendMessage(.sourceHandle , EM_FORMATRANGE , 0 , 0)
                    .FromPage = 1
                    .ToPage = .PreviewPagecount + 1
                    .PreviewPagecount = .ToPage
                    if .Sourcelen > 0 then
                    IF LTRIM$(.Header) > "" THEN
                        .zwstring = REPLACESUBSTR$(.Header , "%PAGE%" , STR$(Pagefound + 1))
                        .PreTextOut(2 + .MarginLeftPix , .MarginTopPix + 2 , REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount)) , -1 , -1)
                    END IF
                    IF LTRIM$(.HeaderMiddle) > "" THEN
                        .zwstring = REPLACESUBSTR$(.HeaderMiddle , "%PAGE%" , STR$(Pagefound + 1))
                        .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                        .PreTextOut((.PagewidthPix - .TextWidth(.zwstring)) / 2 , .MarginTopPix + 2 , .zwstring , -1 , -1)
                    END IF
                    IF LTRIM$(.HeaderRight) > "" THEN
                        .zwstring = REPLACESUBSTR$(.HeaderRight , "%PAGE%" , STR$(Pagefound + 1))
                        .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                        .PreTextOut(.MarginRightPix - .TextWidth(.zwstring) - 10 , .MarginTopPix + 2 , .zwstring , -1 , -1)
                    END IF
                    IF LTRIM$(.Footer) > "" THEN
                        .zwstring = REPLACESUBSTR$(.Footer , "%PAGE%" , STR$(Pagefound + 1))
                        .PreTextOut(2 + .MarginLeftPix , .MarginBottomPix - .Textheight(.zwstring)*1.4 , REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount)) , -1 , -1)
                    END IF
                    IF LTRIM$(.FooterMiddle) > "" THEN
                        .zwstring = REPLACESUBSTR$(.FooterMiddle , "%PAGE%" , STR$(Pagefound + 1))
                        .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                        .PreTextOut((.PagewidthPix - .TextWidth(.zwstring)) / 2 , .MarginBottomPix - .Textheight(.zwstring)*1.4 , .zwstring , -1 , -1)
                    END IF
                    IF LTRIM$(.FooterRight) > "" THEN
                        .zwstring = REPLACESUBSTR$(.FooterRight , "%PAGE%" , STR$(Pagefound + 1))
                        .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                        .PreTextOut(.MarginRightPix - .TextWidth(.zwstring) - 10 , .MarginBottomPix - .Textheight(.zwstring)*1.4 , .zwstring , -1 , -1)
                    END IF
                    end if
                    .hEMF = CloseEnhMetaFile(.hdcMeta)
                ELSE
                    .hEMF = 0
                END IF
            END IF
            .Ctrledit.Text = STR$(.PageIndex + 1) + " " + .CtrlOfText + " " + STR$(.ToPage)
            .CtrlFirst.Enabled = IIF(.PageIndex > 0 , True , False)
            .CtrlPrevious.Enabled = .CtrlFirst.Enabled
            .CtrlNext.Enabled  = IIF(.PageIndex < (.ToPage - 1) , True , False)
            .CtrlLast.Enabled  = .CtrlNext.Enabled
            .CtrlGoto.Enabled = IIF(.PreviewPagecount > 0 , True , False)
            SetFocus(.viewscrollbox.Handle)
            .ChildCanvas_OnPaint
        END SUB

        SUB PreviewForm_OnShow()
            ShowWindow(.hWndForm , 6)
            .viewscrollbox.Repaint
            SetForegroundWindow(.PreviewForm.Handle)
        END SUB

              'This subroutine cleans up the mess created by previewing,
              'then restores the main application's form.
        SUB PreviewForm_OnClose()
            .ViewScrollbox.HorzPosition = 0        'Oddity... you have to reset the Scrollbox's scrollbars back to zero,
            .ViewScrollbox.VertPosition = 0        'otherwise it screws up the preview the next time it's called.
            .PreviewForm.Visible = False
            IF .hdcPanel THEN ReleaseDC(.ChildPanel.Handle , .hdcPanel)
            .hdcPanel = 0
            IF .hEMF THEN DeleteEnhMetaFile(.hEMF)
            .hEMF = 0
            IF .hdcMeta THEN DeleteDC(.hdcMeta)
            .hdcMeta = 0
            ShowWindow(.hWndForm , 9)       '9)
        END SUB

        SUB PreviewExit
            .PreviewForm.Close
        END SUB

        SUB CtrlFirst_OnClick()
            IF .PageIndex > 0 THEN
                .PageIndex = 0
                .GeneratePage(.PageIndex)
            END IF
        END SUB

        SUB CtrlPrevious_OnClick()
            IF .PageIndex > 0 THEN
                .PageIndex = .PageIndex - 1
                .GeneratePage(.PageIndex)
            END IF
        END SUB

        SUB CtrlNext_OnClick()
            IF .PageIndex < (.ToPage - 1) THEN
                .PageIndex = .PageIndex + 1
                .GeneratePage(.PageIndex)
            END IF
        END SUB

        SUB CtrlLast_OnClick()
            IF .PageIndex < (.ToPage - 1) THEN
                .PageIndex = (.ToPage - 1)
                .GeneratePage(.PageIndex)
            END IF
        END SUB

        SUB CalcBounds
            DIM hDesktop AS LONG
            DIM hdcDesktop AS LONG

            DIM lScrnDPIx AS LONG
            DIM lScrnDPIy AS LONG
            .ViewScrollbox.HorzPosition = 0
            .ViewScrollbox.VertPosition = 0

            hDesktop = GetDesktopWindow()
            hdcDesktop = GetWindowDC(hDesktop)
            lScrnDPIx = GetDeviceCaps(hdcDesktop , &H58)       'LOGPIXELSX
            lScrnDPIy = GetDeviceCaps(hdcDesktop , &H5A)       'LOGPIXELSY
            ReleaseDC(hDesktop , hdcDesktop)

            .rcBound.Left = 0
            .rcBound.Top = 0
                  '.rcBound.Right = .PSD.ptPaperSizeX
                  '.rcBound.Bottom = .PSD.ptPaperSizeY
            .rcBound.Right = .Pagewidth * 100
            .rcBound.Bottom = .PageHeight * 100
            .rcChildSize.Left = 0        
            .rcChildSize.Top = 0        
            .rcChildSize.Right = round(.rcBound.Right / lScrnDPIx * 3.78)        
            .rcChildSize.Bottom = round(.rcBound.bottom / lScrnDPIy * 3.78)       
            .ChildPanel.Left = 0
            .ChildPanel.Top = 0
            .ChildPanel.Width = .rcChildSize.Right '- 2 * GetDeviceCaps(.prt_DC , PHYSICALOFFSETX) / lPrntDPIx
            .ChildPanel.Height = .rcChildSize.Bottom '- 2 * GetDeviceCaps(.prt_DC , PHYSICALOFFSETY) / lPrntDPIy

''            .rcChildmargins.Top = .MarginToppix / 6 'lPrntDPIx        '*1.2
''                .rcChildmargins.top = .rcChildSize.bottom * .Margintop / .Pageheight
.rcChildmargins.Top = .rcChildSize.Bottom * .MarginTop / .PageHeight -2
''            .rcChildmargins.Left = .MarginLefTpix / 6 'lPrntDPIy        '*1.2
.rcChildmargins.LefT = .rcChildSize.Right * .MarginLefT / .PageWidth -2
''                .rcChildmargins.Left = .rcChildSize.Right * .MarginLeft / .PageWidth
           ''       .rcChildmargins.right=.childpanel.width-(.PageWidthPix * .Marginright/.PageWidth/lPrntDPIx*lScrnDPIx) '*1.2)
           ''       .rcChildmargins.Bottom=.childpanel.height-(.PageheightPix * .Marginbottom/.Pageheight/lPrntDPIy*lScrnDPIy) '*1.2)
''            .rcChildmargins.right = 10 + .Marginrightpix / lPrntDPIx
            .rcChildmargins.right = .rcChildSize.Right - (.rcChildSize.Right * .MarginrighT / .PageWidth) +2
''            .rcChildmargins.Bottom = 10 + .MarginbottomPix / lPrntDPIy
            .rcChildmargins.bottom = .rcChildSize.Bottom - (.rcChildSize.Bottom * .Marginbottom / .Pageheight) +2
''                .MarginLeftPix = .PageWidthPix * .MarginLeft / .PageWidth

            .PreviewForm.Left = .WR.Left
            .PreviewForm.Top = .WR.Top
            If .CtrlBig.down = true then
                .previewform.ClientHeight = .ChildPanel.Height + 26 + .Scrollbar.Width
                IF .previewform.Top + .previewform.Height > ScreenRect.bottom THEN
                    .previewform.Top = ScreenRect.bottom - .previewform.Height - 2
                    IF .previewform.Top < ScreenRect.Top + 2 THEN .previewform.Top = ScreenRect.Top + 2
                    IF .previewform.Top + .previewform.Height > ScreenRect.bottom THEN .previewform.Height = ScreenRect.bottom - .previewform.Top - 2
                END IF
                .previewform.ClientWidth = .ChildPanel.Width + 4 + IIF(.ChildPanel.Height > .previewform.ClientHeight , .Scrollbar.Width , 0)
                IF .previewform.Left + .previewform.Width > ScreenRect.right THEN
                    .previewform.Left = ScreenRect.right - .previewform.Width - 2
                    IF .previewform.Left < ScreenRect.Left + 2 THEN .previewform.Left = ScreenRect.Left + 2
                    IF .previewform.Left + .previewform.Width > ScreenRect.right THEN .previewform.Width = ScreenRect.right - .previewform.Left - 2
                END IF
            ELSE    
                .PreviewForm.Width = (.WR.Right - .WR.Left)
                .PreviewForm.Height = (.WR.Bottom - .WR.Top)
            END IF

            IF .previewform.ClientWidth > .ChildPanel.Width THEN
                .previewform.ClientWidth = .ChildPanel.Width + 4 + IIF(.ChildPanel.Height > .previewform.ClientHeight , .Scrollbar.Width , 0)
                IF .previewform.ClientHeight > .ChildPanel.Height THEN .previewform.ClientHeight = .ChildPanel.Height + 26        '+ iif(.ChildPanel.Width>.previewform.clientwidth, .Scrollbar.width,0)
            END IF
            IF .previewform.ClientHeight > .ChildPanel.Height THEN
''                .previewform.ClientHeight = .ChildPanel.Height + 26 + IIF(.ChildPanel.Width > .previewform.ClientWidth , .Scrollbar.Width , 0)
                IF .previewform.ClientWidth > .ChildPanel.Width THEN .previewform.ClientWidth = .ChildPanel.Width + 4        '+ iif(.ChildPanel.height>.previewform.clientheight,.Scrollbar.width,0)
            END IF
            IF .Previewform.ClientWidth < 385 THEN .Previewform.ClientWidth = 385
            .ChildCanvas.Left = 0
            .ChildCanvas.Top = 0
            .ChildCanvas.Width = .ChildPanel.Width
            .ChildCanvas.Height = .ChildPanel.Height
            .ViewScrollbox.Left = 0
            .ViewScrollbox.Top = 23
            .ViewScrollbox.Width = .PreviewForm.ClientWidth
            .ViewScrollbox.Height = (.PreviewForm.ClientHeight - 22)
        END SUB

        SUB CtrlPrint_OnClick()
            .parenthandle = .Previewform.Handle
            DEFLNG mode = .PrintDialog(0)
            IF mode > False THEN
                DEFLNG fromZW = .Frompage , ToZw = .Topage
                .CalcBounds
                .GeneratePage(.Pageindex)
                IF mode = PD_Selection THEN
                    .Frompage = .pageindex + 1
                    .topage = .pageindex + 1
                ELSE
                    .Frompage = fromZW
                    .topage = ToZw
                END IF
                IF .prt_DC <> 0 THEN
                    MEMSET(QPrn.FR , 0 , SIZEOF(QPrn.FR))
                    .FR.hdc   = .prt_DC
                    .FR.hdcTarget  = .prt_DC
                    .FR.chrg_cpMin = 0
                    .FR.chrg_cpMax = -1
                    .FR.rcPage_Left = 1440 / .lPrntDPIx * .MarginLeftPix
                    .FR.rc_Left = .FR.rcPage_Left
                    .FR.rcPage_Top = 1440 / .lPrntDPIy * .MarginTopPix
                    IF LTRIM$(.Header) > "" THEN .FR.rcPage_Top = .FR.rcPage_Top + 3000 / .lPrntDPIy * .Textheight(.Header)
                    .FR.rc_Top = .FR.rcPage_Top
                    .FR.rcPage_Right = 1440 / .lPrntDPIx * .MarginRightPix
                    .FR.rc_Right = .FR.rcPage_Right
                    .FR.rcPage_Bottom = 1440 / .lPrntDPIy * .MarginBottomPix
                    IF LTRIM$(.Footer) > "" THEN .FR.rcPage_Bottom = .FR.rcPage_Bottom - 3000 / .lPrntDPIy * .Textheight(.Footer)
                    .FR.rc_Bottom = .FR.rcPage_Bottom
                    DEFLNG iTextOut = 0 , Pagecount = 0        ', iTextAmt = len(.sourceText)
                    .FR.chrg_cpMin = iTextOut
                    .FR.chrg_cpMax = .Sourcelen        'iTextAmt
                    SendMessage(.sourceHandle , EM_FORMATRANGE , 0 , 0)
                    .BeginDoc
                    WHILE (iTextOut < .Sourcelen)       'iTextAmt)
                        iTextOut = SendMessageAPI(.sourceHandle , EM_FORMATRANGE , 0 , .FR)
                        IF (Pagecount >= .Frompage - 1) AND (Pagecount <= .Topage - 1) THEN
                            iTextOut = SendMessageAPI(.sourceHandle , EM_FORMATRANGE , 1 , .FR)
                            IF LTRIM$(.Header) > "" THEN
                                .zwstring = REPLACESUBSTR$(.Header , "%PAGE%" , STR$(Pagecount + 1))
                                .TextOut(2 + .MarginLeftPix , .MarginTopPix + 2 , REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount)) , -1 , -1)
                            END IF
                            IF LTRIM$(.HeaderMiddle) > "" THEN
                                .zwstring = REPLACESUBSTR$(.HeaderMiddle , "%PAGE%" , STR$(Pagecount + 1))
                                .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                                .TextOut((.PagewidthPix - .TextWidth(.zwstring)) / 2 , .MarginTopPix + 2 , .zwstring , -1 , -1)
                            END IF
                            IF LTRIM$(.HeaderRight) > "" THEN
                                .zwstring = REPLACESUBSTR$(.HeaderRight , "%PAGE%" , STR$(Pagecount + 1))
                                .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                                .TextOut(.MarginRightPix - .TextWidth(.zwstring) - 10 , .MarginTopPix + 2 , .zwstring , -1 , -1)
                            END IF
                            IF LTRIM$(.Footer) > "" THEN
                                .zwstring = REPLACESUBSTR$(.Footer , "%PAGE%" , STR$(Pagecount + 1))
                                .TextOut(2 + .MarginLeftPix , .MarginBottomPix - .Textheight(.zwstring)*1.4 , REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount)) , -1 , -1)
                            END IF
                            IF LTRIM$(.FooterMiddle) > "" THEN
                                .zwstring = REPLACESUBSTR$(.FooterMiddle , "%PAGE%" , STR$(Pagecount + 1))
                                .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                                .TextOut((.PagewidthPix - .TextWidth(.zwstring)) / 2 , .MarginBottomPix - .Textheight(.zwstring)*1.4 , .zwstring , -1 , -1)
                            END IF
                            IF LTRIM$(.FooterRight) > "" THEN
                                .zwstring = REPLACESUBSTR$(.FooterRight , "%PAGE%" , STR$(Pagecount + 1))
                                .zwstring = REPLACESUBSTR$(.zwstring , "%PAGES%" , STR$(.PreviewPagecount))
                                .TextOut(.MarginRightPix - .TextWidth(.zwstring) - 10 , .MarginBottomPix - .Textheight(.zwstring) * 1.4 , .zwstring , -1 , -1)
                            END IF
                        END IF
                        IF (iTextOut < .Sourcelen) THEN
                            IF (Pagecount >= .Frompage - 1) AND (Pagecount < .Topage - 1) THEN .NewPage
                            Pagecount = Pagecount + 1
                            .FR.chrg_cpMin = iTextOut
                        END IF
                    WEND
                    SendMessage(.sourceHandle , EM_FORMATRANGE , 0 , 0)
                    .EndDoc
                END IF
                .MakeNewDC
                      '.Calcbounds
                .GeneratePage(.Pageindex)
            END IF
        END SUB

        SUB CtrlPage_OnClick
            .parenthandle = .Previewform.Handle
            IF .PageDialog THEN
                .MakeNewDC
                .CalcBounds
                .GeneratePage(.Pageindex)
                IF .pageindex > .topage THEN
                    .pageindex = .topage - 1
                    .GeneratePage(.Pageindex)
                END IF
            END IF
        END SUB

        SUB CtrlGoto_OnClick
            DEFINT test = VAL(.Ctrledit.Text)
            IF (test > 0) AND (test <= .topage) THEN
                .pageindex = test - 1
                .GeneratePage(.pageindex)
            END IF
        END SUB

        SUB EditOnKeyUp(Key AS WORD , Shift AS INTEGER)
            IF (shift = 0) AND (Key = 13) THEN .CtrlGoto_OnClick
        END SUB

        SUB PreviewOnKeyDown(Key AS WORD , Shift AS INTEGER)
            IF GetFocus() <> .ctrledit.Handle THEN
                IF (shift = 0) and (Key = 27) and (.CancelKey = True) then .PreviewExit
            end if
        end sub
        
        SUB PreviewOnKeyUp(Key AS WORD , Shift AS INTEGER)
            IF GetFocus() <> .ctrledit.Handle THEN
                IF shift = 0 THEN
                    IF Key = 13 THEN
                        .CtrlGoto_OnClick
                    ELSEIF Key = 36 THEN
                        .viewscrollbox.vertposition = 0
                    ELSEIF Key = 33 THEN
                        .CtrlPrevious_OnClick
                    ELSEIF Key = 34 THEN
                        .CtrlNext_OnClick
                    ELSEIF Key = 35 THEN
                        .viewscrollbox.vertposition = .viewscrollbox.vertrange        '99999
                    ELSEIF Key = 38 THEN
                        .viewscrollbox.vertposition = .viewscrollbox.vertposition - 36
                    ELSEIF Key = 40 THEN
                        .viewscrollbox.vertposition = .viewscrollbox.vertposition + 36
                    ELSEIF Key = 37 THEN
                        .viewscrollbox.horzposition = .viewscrollbox.horzposition - 36
                    ELSEIF Key = 39 THEN
                        .viewscrollbox.horzposition = .viewscrollbox.horzposition + 36
                    END IF
                ELSEIF shift = 1 THEN
                    IF Key = 80 THEN
                        .CtrlPrint_OnClick
                    ELSEIF Key = 36 THEN
                        .CtrlFirst_OnClick
                    ELSEIF Key = 35 THEN
                        .CtrlLast_OnClick
                    END IF
                END IF
            END IF
            IF (shift = 16) AND (Key = 88) THEN .PreviewExit
        END SUB

        SUB CtrlBig_OnClick
            .CalcBounds
            SetFocus(.viewscrollbox.Handle)
        END SUB

        FUNCTION PreviewWndproc(Hwnd AS LONG , Msg AS LONG , wParam AS LONG , lParam AS LONG) AS LONG
            SELECT CASE Msg
                CASE &H20A        'WM_MOUSEWHEEL
                    .viewscrollbox.vertposition = .viewscrollbox.vertposition - 12 * SGN(wParam)
                CASE &H20E        'WM_MOUSEHWHEEL
                    .viewscrollbox.Horzposition = .viewscrollbox.horzposition + 12 * SGN(wParam)
            END SELECT
            result = CallWindowProc(.OldWndProc , hwnd , Msg , wParam , lParam)
        END FUNCTION

Public :
              'This subroutine sets the size and location of the preview form to the same size and location as the main application's form.
        SUB PrintPreview(hForm AS LONG , hSource AS LONG , SourceL AS LONG)    
            .hWndForm = hForm
            .PageIndex = 0
            .SourceHandle = hsource
            .SourceLen = sourcel
            .ChildCanvas.Font.Name = .Font.Name
            .ChildCanvas.Font.Size = .Font.Size
            .ChildCanvas.Font.bold = .Font.bold
            .ChildCanvas.Font.italic = .Font.italic
            .ChildCanvas.Font.underline = .Font.underline
            .ChildCanvas.Font.strikeout = .Font.strikeout
            .ChildCanvas.Font.charset = .Font.charset
            .MakeNewDC
            GetWindowRectangle(hForm , .WR)

            .CalcBounds
            .CtrlPanel.Width = .PreviewForm.ClientWidth
            .CtrlPanel.Height = 22
            .CtrlPrint.Width = 20
            .CtrlPrint.Height = 20
            .CtrlPrint.Left = 5
            .CtrlPrint.Top = 2
            .CtrlPage.Width = 20
            .CtrlPage.Height = 20
            .CtrlPage.Left = 30
            .CtrlPage.Top = 2
            .CtrlExit.Width = 20
            .CtrlExit.Height = 20
            .CtrlExit.Left = 55
            .CtrlExit.Top = 2
            .CtrlBreak1.Top = 2
            .CtrlBreak1.Left = 82
            .CtrlBreak1.Height = 20
            .CtrlBreak1.Width = 2
            .CtrlFirst.Width = 20
            .CtrlFirst.Height = 20
            .CtrlFirst.Left = 89        
            .CtrlFirst.Top  = 2
            .CtrlPrevious.Width = 20
            .CtrlPrevious.Height = 20
            .CtrlPrevious.Left = 114    
            .CtrlPrevious.Top  = 2
            .CtrlLabel.Left = 150       
            .CtrlLabel.Top = 10 - .Font.Size / 2
            .CtrlEdit.Left = 155 + .CtrlLabel.Width
            .CtrlEdit.Top = 7 - .Font.Size / 2
            .Ctrledit.Width = 70
            .CtrlGoto.Width = 20
            .CtrlGoto.Height = 20
            .CtrlGoto.Left = .CtrlEdit.Left + 75       
            .CtrlGoto.Top  = 2
            .CtrlNext.Width = 20
            .CtrlNext.Height = 20
            .CtrlNext.Left = .CtrlGoto.Left + 40       
            .CtrlNext.Top  = 2
            .CtrlLast.Width = 20
            .CtrlLast.Height = 20
            .CtrlLast.Left = .CtrlNext.Left + 25       
            .CtrlLast.Top  = 2
            .CtrlBreak2.Top = 2
            .CtrlBreak2.Left = .CtrlLast.Left + 27
            .CtrlBreak2.Height = 20
            .CtrlBreak2.Width = 2
            .CtrlBig.Width = 20
            .CtrlBig.Height = 20
            .CtrlBig.Left = .CtrlBreak2.Left + 7
            .CtrlBig.Top  = 2
            .hdcPanel = GetDC(.ChildPanel.Handle)
            .GeneratePage(.Pageindex)
            $IFDEF __RQINC2
                IF .bindindex = 0 THEN
                    BIND QPrn.BindIndex TO QPrn.PreviewWndproc
                    .mywndproc = SetNewCallBack_4(.BindIndex)
                    .OldWndProc = SetWindowLong(.previewForm.Handle , GWL_WNDPROC , .mywndproc)
                END IF
            $ENDIF
            .PreviewForm.Show
        END SUB

        CONSTRUCTOR
            ParentHandle = application.Handle
            DisablePrinter = True
            DisablePaper = False
            DisableOrient = False
            DisableMargins = False
            bindindex = False
            Copies = 1
            Printername = ""
            Header = ""
            HeaderMiddle = ""
            HeaderRight = ""
            Footer = ""
            FooterMiddle = ""
            FooterRight = ""
            DefaultSource = 7
            PrintQuality = -1
            Printcolor = 2
            Duplex = True
            Collate = False
            MaxPages = 9999
            FromPage = 1
            ToPage = 9999
            MeterInch = PSD_INHUNDREDTHSOFMILLIMETERS
            PageWidth = 0
            PageHeight = 0
            prt_Handle = 0
            prt_DC = 0
            jobID = 0
            Penstyle = PS_SOLID
            PenSize = 12
            Brushstyle = BS_HATCHED
            BrushHatch = HS_SOLID
            CopyMode = SRCCOPY
            BkMode = OPAQUE
            Title = LEFT$(Application.exename , rinstr(Application.exename , ".") - 1)
            Initialise
            PreviewForm.BorderStyle = bsDialog
            PreviewForm.Caption  = " Print Preview"
            PreviewForm.OnShow   = QPrn.PreviewForm_OnShow
            PreviewForm.OnClose  = QPrn.PreviewForm_OnClose
            PreviewForm.ShowHint  = True
            PreviewForm.OnKeyDown  = QPrn.PreviewOnKeyDown
            PreviewForm.OnKeyUp  = QPrn.PreviewOnKeyUp
            PreviewForm.KeyPreview  = True

            CtrlPanel.Parent   = .PreviewForm
            CtrlPanel.BevelOuter  = bvNone
            CtrlPanel.BevelInner  = bvNone
            CtrlPanel.BevelWidth  = 0
            CtrlPrint.Parent   = .CtrlPanel
            CtrlPrint.Font.Name  = "Webdings"
            CtrlPrint.Font.Size  = 14
            CtrlPrint.Caption   = CHR$(202)
            CtrlPrint.OnClick   = QPrn.CtrlPrint_OnClick
            CtrlPrint.Hint = "Print (Ctrl-P)"
            CtrlPrint.Flat  = True
            CtrlPage.Parent   = .CtrlPanel
            CtrlPage.Font.Name  = "Webdings"
            CtrlPage.Font.Size  = 12
            CtrlPage.Caption   = CHR$(49)
            CtrlPage.OnClick   = QPrn.CtrlPage_OnClick
            CtrlPage.Hint = "PageSetup"
            CtrlPage.Flat  = True
            CtrlExit.Parent   = .CtrlPanel
            CtrlExit.Font.Name  = "Webdings"
            CtrlExit.Font.Size  = 14
            CtrlExit.Caption   = CHR$(114)
            CtrlExit.OnClick   = QPrn.PreviewExit
            CtrlExit.Hint = "Exit"
            CtrlExit.Flat  = True
            CtrlBreak1.Parent   = .CtrlPanel
            CtrlBreak1.BevelOuter = bvLowered
            CtrlFirst.Parent   = .CtrlPanel
            CtrlFirst.Layout   = blBMPBottom
            CtrlFirst.Font.Name  = "Webdings"
            CtrlFirst.Font.Size  = 12
            CtrlFirst.Caption   = CHR$(57)
            CtrlFirst.OnClick   = QPrn.CtrlFirst_OnClick
            CtrlFirst.Hint = "First page"
            CtrlFirst.Flat  = True
            CtrlPrevious.Parent  = .CtrlPanel
            CtrlPrevious.Font.Name  = "Webdings"
            CtrlPrevious.Font.Size  = 12
            CtrlPrevious.Caption  = CHR$(51)
            CtrlPrevious.OnClick  = QPrn.CtrlPrevious_OnClick
            CtrlPrevious.Hint = "Previous page"
            CtrlPrevious.NumBMPs  = 1
            CtrlPrevious.Flat  = True
            CtrlLabel.Parent  = .CtrlPanel
            CtrlLabel.AutoSize = True
            CtrlLabel.Caption = "Page:"
            CtrlEdit.Parent  = .CtrlPanel
            CtrlEdit.OnKeyUp  = QPrn.EditOnKeyUp
            CtrlOfText = "of"
            CtrlGoto.Parent  = .CtrlPanel
            CtrlGoto.Font.Name  = "Webdings"
            CtrlGoto.Font.Size  = 14
            CtrlGoto.Caption  = CHR$(113)       '96)
            CtrlGoto.OnClick  = QPrn.CtrlGoto_OnClick
            CtrlGoto.Hint = "Goto page"
            CtrlGoto.Flat  = True
            CtrlNext.Parent   = .CtrlPanel
            CtrlNext.Font.Name   = "Webdings"
            CtrlNext.Font.Size   = 12
            CtrlNext.Caption   = CHR$(52)
            CtrlNext.OnClick   = QPrn.CtrlNext_OnClick
            CtrlNext.Hint = "Next page"
            CtrlNext.Flat  = True
            CtrlLast.Parent   = .CtrlPanel
            CtrlLast.Layout   = blBMPBottom
            CtrlLast.Font.Name   = "Webdings"
            CtrlLast.Font.Size   = 12
            CtrlLast.Caption   = CHR$(58)
            CtrlLast.OnClick   = QPrn.CtrlLast_OnClick
            CtrlLast.Hint = "Last page"
            CtrlLast.Flat  = True
            CtrlBreak2.Parent   = .CtrlPanel
            CtrlBreak2.BevelOuter = bvLowered
            CtrlBig.Parent   = .CtrlPanel
            CtrlBig.Font.Name   = "Webdings"
            CtrlBig.Font.Size   = 12
            CtrlBig.Caption   = CHR$(99)
            CtrlBig.OnClick   = QPrn.CtrlBig_OnClick
            CtrlBig.Hint = "Big/Small Preview"
            CtrlBig.Flat  = True
            CtrlBig.Groupindex  = 2
            CtrlBig.allowAllUp = True

            ViewScrollbox.Parent  = .PreviewForm
            ViewScrollBox.HorzTracking = True
            ViewScrollBox.VertTracking = True
            ViewScrollbox.Color  = RGB(000 , 000 , 000)
            ChildPanel.Parent   = .ViewScrollbox        
            ChildPanel.BevelOuter  = bvNone
            ChildPanel.BevelInner  = bvNone
            ChildPanel.BevelWidth  = 0
            ChildPanel.Color    = RGB(255 , 255 , 255)
            ChildCanvas.Parent   = .ChildPanel
            ChildCanvas.OnPaint   = QPrn.ChildCanvas_OnPaint
            Scrollbar.Kind = 1        'Vertical'
            CancelKey = True
        END CONSTRUCTOR
    END WITH
END TYPE


